
open HolKernel Parse boolLib bossLib arithmeticTheory pred_setTheory
     listTheory sequenceTheory state_transformerTheory
     probabilityTheory formalizeUseful extra_numTheory combinTheory
     pairTheory realTheory realLib extra_boolTheory jrhUtils
     extra_pred_setTheory prob_algebraTheory probTheory realSimps
     extra_pred_setTools measureTheory numTheory
     simpLib prob_extraTheory probTools prob_extraTools pred_setLib
     subtypeTheory seqTheory std_unifTheory cdfTheory
     limTheory transcTheory;

val _ = new_theory "itm";


val CDF_UNIF_CONT_GT0_LT1 = store_thm
    ("CDF_UNIF_CONT_GT0_LT1",
    (--`!x. (0 < x) /\ (x < 1) ==>
        (prob bern {s | std_unif_cont s <= x} = x)`--),
	REPEAT GEN_TAC THEN
	MP_TAC (Q.SPEC `x` CDF_UNIF_CONT_GE0_LT1) THEN
	RW_TAC std_ss [REAL_LE_LT]);

val CDF_UNIF_CONT_GE0_LE1 = store_thm
    ("CDF_UNIF_CONT_GE0_LE1",
    (--`!x. (0 <= x) /\ (x <= 1) ==>
        (prob bern {s | std_unif_cont s <= x} = x)`--),
	REPEAT GEN_TAC THEN
	KNOW_TAC `x <= 1 = ((x < 1) \/ (x = 1))` THEN1
        	RW_TAC std_ss [REAL_LE_LT] THEN
	ASM_REWRITE_TAC [] THEN
	RW_TAC std_ss [] THENL [
        	RW_TAC std_ss [CDF_UNIF_CONT_GE0_LT1],
        	MATCH_MP_TAC CDF_UNIF_CONT_GE1 THEN
        	PROVE_TAC [REAL_LE_REFL]]);

val STD_UNIF_CONT_NEQ_0_1 = store_thm 
    ("STD_UNIF_CONT_NEQ_0_1",
    (--`!(a:num -> bool). 
	~(std_unif_cont a = 1) /\ 
	~(std_unif_cont a = 0) ==>
	((std_unif_cont a < 1) /\ 
	(0 < std_unif_cont a))`--),
	RW_TAC std_ss [] THENL [
		MP_TAC (Q.SPEC `a` UB_STD_UNIF_CONT) THEN
		RW_TAC std_ss [REAL_LE_LT],
		
		MP_TAC (Q.SPEC `a` LB_STD_UNIF_CONT) THEN
		RW_TAC std_ss [REAL_LE_LT]]);

val FN_MONO_INV_FN_STRICT_MONO = store_thm
    ("FN_MONO_INV_FN_STRICT_MONO",
(--`!f g a b.  
	(!a b. a < b ==> g a <= g b) /\ 
	(!x. ((0 < x) /\ (x < 1)) ==> (g (f x) = x)) /\
		(0 < a) /\ (a < 1) /\ (0 < b) /\ (b < 1) ==>
			((f a < f b) = (a < b))`--),
	RW_TAC std_ss [] THEN
	EQ_TAC THENL [
		RW_TAC std_ss [] THEN
		KNOW_TAC `g (f a) <= g (f b)` THEN1
				PROVE_TAC [] THEN
		KNOW_TAC `(g (f a) = a) /\ (g (f b) = b)` THEN1
			RW_TAC std_ss [] THEN
	
		FULL_SIMP_TAC std_ss [REAL_LE_LT] THEN
		KNOW_TAC `f a = f b` THEN1
			RW_TAC std_ss [] THEN
		CCONTR_TAC THEN
		UNDISCH_TAC (--`(f:real -> real) (a:real) < f (b:real)`--) THEN
		REWRITE_TAC [REAL_NOT_LT] THEN
		MATCH_MP_TAC REAL_EQ_IMP_LE THEN
		PROVE_TAC [],
	
		RW_TAC std_ss [] THEN
		CCONTR_TAC THEN
		FULL_SIMP_TAC std_ss [REAL_NOT_LT] THEN
		KNOW_TAC `g (f b) <= g (f a)` THEN1 (
			POP_ASSUM MP_TAC THEN
			NTAC 6 (POP_ASSUM K_TAC) THEN
			RW_TAC std_ss [REAL_LE_LT] THEN1	
				RW_TAC std_ss [GSYM REAL_LE_LT] THEN
	
				DISJ2_TAC THEN
				PROVE_TAC []) THEN
		KNOW_TAC `(g (f a) = a) /\ (g (f b) = b)` THEN1
			RW_TAC std_ss [] THEN
		FULL_SIMP_TAC std_ss [real_lte]]);

val SET_DIFF_STD_UNIF_CONT_0_1 = store_thm
    ("SET_DIFF_STD_UNIF_CONT_0_1",
    (--`!(f:real -> real) x.
        {s | f (std_unif_cont s) <= x} IN events bern  ==>
        (prob bern {s | f (std_unif_cont s) <= x} =
        prob bern (({s | f (std_unif_cont s) <= x} DIFF
                        {s | std_unif_cont s = 1}) DIFF
                        {s | std_unif_cont s = 0}))`--),
	RW_TAC std_ss [] THEN
	KNOW_TAC `({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) <= x}) \/
                        ~({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) <= x})` THEN1
        	PROVE_TAC [] THENL [
	KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x})` THEN1
        	PROVE_TAC [] THENL [
	MATCH_MP_TAC RAND_THM THEN
	FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        DIFF_DEF, GSPECIFICATION] THEN
	REWRITE_TAC [EXTENSION] THEN
	PSET_TAC [GSPECIFICATION] THEN
	Cases_on `std_unif_cont x''' = 1` THEN1
        	RW_TAC std_ss [real_lte] THEN

		RW_TAC std_ss [] THEN
		Cases_on `std_unif_cont x''' = 0` THEN1
			RW_TAC std_ss [real_lte] THEN
		RW_TAC std_ss [],

	KNOW_TAC `prob bern {s | f (std_unif_cont s) <= x} =
        prob bern ({s | std_unif_cont s = 0} UNION
                ({s | f (std_unif_cont s) <= x} DIFF
                                        {s | std_unif_cont s = 0}))` THEN1 (
		MATCH_MP_TAC RAND_THM THEN
		RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        	FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
        	REWRITE_TAC [EXTENSION] THEN
        	RW_TAC std_ss [GSPECIFICATION] THEN
        	POP_ASSUM (MP_TAC o Q.SPEC `x''`) THEN
        	PROVE_TAC []) THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	POP_ASSUM K_TAC THEN
	KNOW_TAC `prob bern
      		({s | std_unif_cont s = 0} UNION
       		({s | f (std_unif_cont s) <= x} DIFF {s | std_unif_cont s = 0})) =
       		 prob bern {s | std_unif_cont s = 0} +
        	prob bern ({s | f (std_unif_cont s) <= x} DIFF {s | std_unif_cont s = 0})` THEN1 (
			MATCH_MP_TAC PROB_ADDITIVE THEN
			RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                		EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
			RW_TAC std_ss [DISJOINT_DEF, DIFF_DEF,
                                GSPECIFICATION, INTER_DEF] THEN
        		REWRITE_TAC [EXTENSION, GSYM GSPEC_F] THEN
        		RW_TAC std_ss [GSPECIFICATION] THEN
        		PROVE_TAC []) THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	RW_TAC real_ss [PMF_STD_UNIF_CONT] THEN
	MATCH_MP_TAC RAND_THM THEN
	FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        DIFF_DEF, GSPECIFICATION] THEN
	REWRITE_TAC [EXTENSION] THEN
	PSET_TAC [GSPECIFICATION] THEN
	Cases_on `std_unif_cont x'' = 1` THEN1
        	RW_TAC std_ss [real_lte] THEN
        	RW_TAC std_ss []],


	KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x})` THEN1
        	PROVE_TAC [] THENL [
	KNOW_TAC `prob bern {s | f (std_unif_cont s) <= x} =
        prob bern ({s | std_unif_cont s = 1} UNION
                ({s | f (std_unif_cont s) <= x} DIFF
                                        {s | std_unif_cont s = 1}))` THEN1 (
		MATCH_MP_TAC RAND_THM THEN
		RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        	FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
        	REWRITE_TAC [EXTENSION] THEN
        	RW_TAC std_ss [GSPECIFICATION] THEN
		POP_ASSUM K_TAC THEN
		POP_ASSUM K_TAC THEN
        	POP_ASSUM (MP_TAC o Q.SPEC `x''`) THEN
        	PROVE_TAC []) THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	KNOW_TAC `prob bern
      		({s | std_unif_cont s = 1} UNION
       		({s | f (std_unif_cont s) <= x} DIFF {s | std_unif_cont s = 1})) =
        	prob bern {s | std_unif_cont s = 1} +
        	prob bern ({s | f (std_unif_cont s) <= x} DIFF {s | std_unif_cont s = 1})` THEN1 (
        		MATCH_MP_TAC PROB_ADDITIVE THEN
        		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                	EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
        		RW_TAC std_ss [DISJOINT_DEF, DIFF_DEF,
                                GSPECIFICATION, INTER_DEF] THEN
        		REWRITE_TAC [EXTENSION, GSYM GSPEC_F] THEN
        		RW_TAC std_ss [GSPECIFICATION] THEN
        		PROVE_TAC []) THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	RW_TAC real_ss [PMF_STD_UNIF_CONT] THEN
	MATCH_MP_TAC RAND_THM THEN
	FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        DIFF_DEF, GSPECIFICATION] THEN
	REWRITE_TAC [EXTENSION] THEN
	PSET_TAC [GSPECIFICATION] THEN
	Cases_on `std_unif_cont x'' = 0` THEN1
        	RW_TAC std_ss [real_lte] THEN
		RW_TAC std_ss [real_lte],


	KNOW_TAC `prob bern {s | f (std_unif_cont s) <= x} =
        prob bern ({s | std_unif_cont s = 1} UNION
                ({s | f (std_unif_cont s) <= x} DIFF
                                        {s | std_unif_cont s = 1}))` THEN1 (
		MATCH_MP_TAC RAND_THM THEN
		RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        	FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
        	REWRITE_TAC [EXTENSION] THEN
        	RW_TAC std_ss [GSPECIFICATION] THEN
        	POP_ASSUM K_TAC THEN
        	POP_ASSUM (MP_TAC o Q.SPEC `x'`) THEN
        	PROVE_TAC []) THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	KNOW_TAC `prob bern
      	({s | std_unif_cont s = 1} UNION
       ({s | f (std_unif_cont s) <= x} DIFF {s | std_unif_cont s = 1})) =
        prob bern {s | std_unif_cont s = 1} +
        prob bern ({s | f (std_unif_cont s) <= x} DIFF {s | std_unif_cont s = 1})` THEN1 (
        	MATCH_MP_TAC PROB_ADDITIVE THEN
        	RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
        	RW_TAC std_ss [DISJOINT_DEF, DIFF_DEF,
                                GSPECIFICATION, INTER_DEF] THEN
        	REWRITE_TAC [EXTENSION, GSYM GSPEC_F] THEN
        	RW_TAC std_ss [GSPECIFICATION] THEN
        	PROVE_TAC []) THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	RW_TAC real_ss [PMF_STD_UNIF_CONT] THEN

	KNOW_TAC `prob bern ({s | f (std_unif_cont s) <= x} DIFF {s | std_unif_cont s = 1}) =
        prob bern ({s | std_unif_cont s = 0} UNION
                (({s | f (std_unif_cont s) <= x} DIFF {s | std_unif_cont s = 1}) DIFF
                                        {s | std_unif_cont s = 0}))` THEN1 (
		MATCH_MP_TAC RAND_THM THEN
		KNOW_TAC `{s | std_unif_cont s = 0} SUBSET
        	({s | f (std_unif_cont s) <= x} DIFF {s | std_unif_cont s = 1})` THEN1 (
			FULL_SIMP_TAC std_ss [DIFF_DEF, SUBSET_DEF, 
				GSPECIFICATION, IMP_DISJ_THM] THEN
			RW_TAC std_ss [LEFT_OR_OVER_AND, GSPECIFICATION] THEN
			CCONTR_TAC THEN
			FULL_SIMP_TAC std_ss [] THEN
			FULL_SIMP_TAC real_ss []) THEN

	
	RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        	FULL_SIMP_TAC std_ss [SUBSET_DEF, DIFF_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
        	REWRITE_TAC [EXTENSION] THEN
        	RW_TAC std_ss [GSPECIFICATION] THEN
        	POP_ASSUM (MP_TAC o Q.SPEC `x'`) THEN
        	PROVE_TAC []) THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	KNOW_TAC `prob bern
      ({s | std_unif_cont s = 0} UNION
       (({s | f (std_unif_cont s) <= x} DIFF {s | std_unif_cont s = 1})
		 DIFF {s | std_unif_cont s = 0})) =
        prob bern {s | std_unif_cont s = 0} +
        prob bern (({s | f (std_unif_cont s) <= x} DIFF {s | std_unif_cont s = 1})
		 DIFF {s | std_unif_cont s = 0})` THEN1 (
        	MATCH_MP_TAC PROB_ADDITIVE THEN
        	RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
	
        	RW_TAC std_ss [DISJOINT_DEF, DIFF_DEF,
                                GSPECIFICATION, INTER_DEF] THEN
        	REWRITE_TAC [EXTENSION, GSYM GSPEC_F] THEN
        	RW_TAC std_ss [GSPECIFICATION] THEN
        	PROVE_TAC []) THEN
		RW_TAC real_ss [PMF_STD_UNIF_CONT]]]);

(*================================================================*);


val INV_CDF_FN_def  = Define
        `INV_CDF_FN  (f: real -> real) (g: real -> real) =
                (!x. (g x = 0) ==> (x <= f (g x))) /\
		(!x. (g x = 1) ==> (f (g x) <= x)) /\
                (!x. (0 < g x /\ g x < 1) ==>
                        (f (g x) = x) /\ (!x. 0 < x /\ x < 1 ==> (g (f x) = x)))`;

val IS_CONT_CDF_FN_def = Define
        `IS_CONT_CDF_FN (g: real -> real) =
                (!a b. a < b ==> g a <= g b) /\
                ((\n. g ((\n. &n) n)) --> 1) /\
                ((\n. g ((\n. ~&n) n)) --> 0) /\
                (!x. g contl x)`;

val LIM_POS1_NEG0_IMP_GE0_LE1 = store_thm
  ("LIM_POS1_NEG0_IMP_GE0_LE1",
  (--`!g. IS_CONT_CDF_FN g ==>
        (!x. 0 <= g x /\ g x <= 1)`--),
RW_TAC std_ss [IS_CONT_CDF_FN_def] THENL [
        MATCH_MP_TAC REAL_LE_TRANS THEN
        EXISTS_TAC (--`(g:real -> real) ~(&(ceiling (abs (x:real)) ))`--) THEN
        CONJ_TAC THENL [
                KNOW_TAC `g ~(& (ceiling (abs x) )) =
                        (\n. g ~& n) (ceiling (abs x))` THEN1
                        RW_TAC std_ss [] THEN
                ASM_REWRITE_TAC [] THEN
                MATCH_MP_TAC SEQ_LE_MONO THEN
                RW_TAC std_ss [] THEN
                KNOW_TAC `~& (n + 1) < ~& n` THEN1
                        RW_TAC arith_ss [REAL_LT_NEG, REAL_LT] THEN
                PROVE_TAC [],

        KNOW_TAC `~& (ceiling (abs x)) <= x` THEN1 (
                Cases_on `x < 0` THENL [
                        MATCH_MP_TAC REAL_LE_TRANS THEN
                        EXISTS_TAC (--`~ abs x:real`--) THEN
                        RW_TAC real_ss [REAL_LE_NEG, LB_CEILING,
                                        abs, real_lte, REAL_LT_REFL], 

                        FULL_SIMP_TAC real_ss [REAL_LE_LNEG, REAL_LE_ADD, REAL_NOT_LT]]) THEN
        POP_ASSUM MP_TAC THEN
        PROVE_TAC [REAL_LE_LT]],

        MATCH_MP_TAC REAL_LE_TRANS THEN
        EXISTS_TAC (--`(g:real -> real) (&(ceiling (abs (x:real)) ))`--) THEN
        CONJ_TAC THENL [
                KNOW_TAC `x <= & (ceiling (abs x))` THEN1 (
                        MATCH_MP_TAC REAL_LE_TRANS THEN
                        EXISTS_TAC (--`abs (x:real)`--) THEN
                        RW_TAC std_ss [ABS_LE, LB_CEILING]) THEN
                PROVE_TAC [REAL_LE_LT],

                KNOW_TAC `g (& (ceiling (abs x) )) =
                        (\n. g (& n)) (ceiling (abs x))` THEN1
                        RW_TAC std_ss [] THEN
                ASM_REWRITE_TAC [] THEN
                MATCH_MP_TAC SEQ_MONO_LE THEN
                RW_TAC std_ss [] THEN
                KNOW_TAC `&n < & (n + 1)` THEN1
                        RW_TAC arith_ss [REAL_LT] THEN
                PROVE_TAC []]]);

val CONT_CDF_EXISTS_GT0_LT1 = store_thm
  ("CONT_CDF_EXISTS_GT0_LT1",
(--`!g. IS_CONT_CDF_FN g ==>
       (?y. 0 < g y /\ g y < 1)`--),
GEN_TAC THEN
DISCH_TAC THEN
KNOW_TAC `(!x. 0 <= g x /\ g x <= 1)` THEN1
        PROVE_TAC [LIM_POS1_NEG0_IMP_GE0_LE1] THEN
NTAC 2 (POP_ASSUM MP_TAC) THEN
REWRITE_TAC [AND_IMP_INTRO] THEN
ONCE_REWRITE_TAC [CONJ_SYM] THEN
RW_TAC std_ss [IS_CONT_CDF_FN_def] THEN
ONCE_REWRITE_TAC [CONJ_SYM] THEN

FULL_SIMP_TAC std_ss [SEQ] THEN
POP_ASSUM MP_TAC THEN
POP_ASSUM (MP_TAC o Q.SPEC `1`) THEN
RW_TAC real_ss [] THEN
POP_ASSUM MP_TAC THEN
POP_ASSUM (MP_TAC o Q.SPEC `SUC N`) THEN
KNOW_TAC `!x. abs (g x) = g x` THEN
      RW_TAC std_ss [ABS_REFL] THEN
RW_TAC real_ss [REAL_SUB_LT] THEN
NTAC 3 (POP_ASSUM MP_TAC) THEN
POP_ASSUM (MP_TAC o Q.SPEC `1`) THEN
RW_TAC real_ss [] THEN
NTAC 3 (POP_ASSUM MP_TAC) THEN
POP_ASSUM (MP_TAC o Q.SPEC `SUC N'`) THEN
RW_TAC real_ss [GSYM ABS_BETWEEN, REAL_SUB_SUB2, REAL_SUB_LT] THEN
KNOW_TAC `~& (SUC N) < (& (SUC N'))` THEN1
                RW_TAC arith_ss [lt_int] THEN
KNOW_TAC `g (~& (SUC N)) <= g (& (SUC N'))` THEN1
                RW_TAC std_ss [] THEN
POP_ASSUM MP_TAC THEN
REWRITE_TAC [REAL_LE_LT] THEN
STRIP_TAC THENL [
        Cases_on `g ~& (SUC N) < 0` THEN1
                        PROVE_TAC [REAL_NOT_LE] THEN
                FULL_SIMP_TAC std_ss [REAL_NOT_LT] THEN
                POP_ASSUM MP_TAC THEN
                REWRITE_TAC [REAL_LE_LT] THEN
                STRIP_TAC THEN1 (
                        EXISTS_TAC (--`~& (SUC N)`--) THEN
                        PROVE_TAC []) THEN

                        POP_ASSUM MP_TAC THEN
                        ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
                        Cases_on `1 < g (& (SUC N'))` THEN1
                                PROVE_TAC [REAL_NOT_LE] THEN
                        FULL_SIMP_TAC std_ss [REAL_NOT_LT] THEN
                        POP_ASSUM MP_TAC THEN
                        REWRITE_TAC [REAL_LE_LT] THEN
                        REPEAT STRIP_TAC THEN1 (
                                EXISTS_TAC (--`& (SUC N')`--) THEN
                                PROVE_TAC []) THEN
                                MP_TAC (Q.SPECL [`g`, `~& (SUC N)`,
                                `(& (SUC N'))`, `1 / 2`] IVT) THEN
                                RW_TAC real_ss [REAL_EQ_IMP_LE, REAL_LT_IMP_LE] THEN
                                EXISTS_TAC (--`x:real`--) THEN
                                RW_TAC real_ss [],
        PROVE_TAC []]);


val FN_STD_UNIF_CONT_EQ_EVENTS_BERN = store_thm 
    ("FN_STD_UNIF_CONT_EQ_EVENTS_BERN",
    (--`!f g x. IS_CONT_CDF_FN g /\
	(INV_CDF_FN f g) ==>
	{s | f (std_unif_cont s) = x} IN events bern`--),
REPEAT STRIP_TAC THEN
POP_ASSUM MP_TAC THEN
KNOW_TAC `(!x. 0 <= g x /\ g x <= 1)` THEN1
        PROVE_TAC [LIM_POS1_NEG0_IMP_GE0_LE1] THEN
UNDISCH_TAC (--`IS_CONT_CDF_FN g`--) THEN
DISCH_TAC THEN

KNOW_TAC `(?y. 0 < g y /\ g y < 1)` THEN1
        PROVE_TAC [CONT_CDF_EXISTS_GT0_LT1] THEN
STRIP_TAC THEN
FULL_SIMP_TAC std_ss [INV_CDF_FN_def, IS_CONT_CDF_FN_def] THEN

	KNOW_TAC `!x. 0 < x /\ x < 1 ==> (g (f x) = x)` THEN1 (
        	POP_ASSUM (MP_TAC o Q.SPEC `y:real`) THEN
        	PROVE_TAC []) THEN
	Cases_on `g x <= 0` THENL [
        	POP_ASSUM MP_TAC THEN
        	RW_TAC std_ss [REAL_LE_LT] THEN1
                	PROVE_TAC [real_lt] THEN
        	KNOW_TAC `x <= f 0` THEN1
                	PROVE_TAC [] THEN
        	UNDISCH_TAC (--`(x:real) <= (f:real -> real) (0:real)`--) THEN
        	REWRITE_TAC [REAL_LE_LT] THEN
        	REPEAT STRIP_TAC THENL [
             
	
		
		KNOW_TAC `({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) = x}) \/
                        ~({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) = x})` THEN1
			PROVE_TAC [] THENL [
		KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) = x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) = x})` THEN1
                	PROVE_TAC [] THENL [

		KNOW_TAC `{s | f (std_unif_cont s) = x} =
	        (({s | std_unif_cont s = g x} DIFF
                        {s | std_unif_cont s = 1}) DIFF
                        {s | std_unif_cont s = 0})` THEN1 (
	        	RW_TAC std_ss [SET_EQ_SUBSET] THENL [
	        		FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
	        		GEN_TAC THEN
        			Cases_on `std_unif_cont x''' = 1` THEN1
                			PROVE_TAC [] THEN
				Cases_on `std_unif_cont x''' = 0` THEN1
					PROVE_TAC [] THEN
				STRIP_TAC THEN
				KNOW_TAC `g (f (std_unif_cont x''')) = g x` THEN1
					PROVE_TAC [] THEN
				KNOW_TAC `g (f (std_unif_cont x''')) = (std_unif_cont x''')` THEN1
					PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
				PROVE_TAC [],

				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                                	DIFF_DEF, GSPECIFICATION] THEN
				GEN_TAC THEN
				Cases_on `std_unif_cont x''' = 1` THEN1
                                	PROVE_TAC [] THEN
                        	Cases_on `std_unif_cont x''' = 0` THEN1
                                	PROVE_TAC [] THEN
                        	RW_TAC std_ss []]) THEN
		ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN],

		KNOW_TAC `{s | f (std_unif_cont s) = x} =
        	{s | std_unif_cont s = 0} UNION
                ({s | f (std_unif_cont s) = x} DIFF
                                        {s | std_unif_cont s = 0})` THEN1 (
        		RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        		FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
        		REWRITE_TAC [EXTENSION] THEN
        		RW_TAC std_ss [GSPECIFICATION] THEN
        		PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `{s | f (std_unif_cont s) = x} DIFF
                        {s | std_unif_cont s = 0} =
                	(({s | std_unif_cont s = g x} DIFF
                        {s | std_unif_cont s = 1}) DIFF
                        {s | std_unif_cont s = 0})` THEN1 (
	        	RW_TAC std_ss [SET_EQ_SUBSET] THENL [
        			FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
				GEN_TAC THEN
				Cases_on `std_unif_cont x'' = 1` THEN1
					PROVE_TAC [] THEN
				Cases_on `std_unif_cont x'' = 0` THEN1
					PROVE_TAC [] THEN
				DISJ1_TAC THEN
				CCONTR_TAC THEN
				FULL_SIMP_TAC std_ss [] THEN
				KNOW_TAC `g (f (std_unif_cont x'')) = g x` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				KNOW_TAC `g (f (std_unif_cont x'')) = (std_unif_cont x'')` THEN1
					PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
				PROVE_TAC [],
	
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                                DIFF_DEF, GSPECIFICATION] THEN
				PROVE_TAC []]) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
        	POP_ASSUM K_TAC THEN
        	POP_ASSUM K_TAC THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN]],
	
		KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) = x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) = x})` THEN1
                	PROVE_TAC [] THENL [

		KNOW_TAC `{s | f (std_unif_cont s) = x} =
        		{s | std_unif_cont s = 1} UNION
                	({s | f (std_unif_cont s) = x} DIFF
                                        {s | std_unif_cont s = 1})` THEN1 (
        		RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        		FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
        		REWRITE_TAC [EXTENSION] THEN
        		RW_TAC std_ss [GSPECIFICATION] THEN
        		PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `{s | f (std_unif_cont s) = x} DIFF
                        {s | std_unif_cont s = 1} =
                	(({s | std_unif_cont s = g x} DIFF
                        {s | std_unif_cont s = 0}) DIFF
                        {s | std_unif_cont s = 1})` THEN1(
	        	RW_TAC std_ss [SET_EQ_SUBSET] THENL [
        			FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
				GEN_TAC THEN
				Cases_on `std_unif_cont x'' = 1` THEN1
					PROVE_TAC [] THEN
				Cases_on `std_unif_cont x'' = 0` THEN1
					PROVE_TAC [] THEN
				DISJ1_TAC THEN
				CCONTR_TAC THEN
				FULL_SIMP_TAC std_ss [] THEN
				KNOW_TAC `g (f (std_unif_cont x'')) = g x` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				KNOW_TAC `g (f (std_unif_cont x'')) = (std_unif_cont x'')` THEN1
					PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
				PROVE_TAC [],
	
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                                	DIFF_DEF, GSPECIFICATION]]) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN],

		KNOW_TAC `{s | f (std_unif_cont s) = x} =
        	({s | std_unif_cont s = 1} UNION
		({s | std_unif_cont s = 0} UNION
                (({s | f (std_unif_cont s) = x} DIFF
                                        {s | std_unif_cont s = 1}) DIFF 
					{s | std_unif_cont s = 0})))` THEN1 (
			RW_TAC std_ss [UNION_DEF, DIFF_DEF, 
			LEFT_OR_OVER_AND, GSPECIFICATION] THEN
			FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
			REWRITE_TAC [EXTENSION] THEN
			RW_TAC std_ss [GSPECIFICATION] THEN
			PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `({s | f (std_unif_cont s) = x} 
			DIFF {s | std_unif_cont s = 1} 
			DIFF {s | std_unif_cont s = 0}) = 
			(({s | std_unif_cont s = g x} DIFF 
			{s | std_unif_cont s = 1}) DIFF 
			{s | std_unif_cont s = 0})` THEN1 (
			RW_TAC std_ss [DIFF_DEF, EXTENSION] THEN
			PSET_TAC [GSPECIFICATION] THEN
			POP_ASSUM K_TAC THEN
			EQ_TAC THENL [
				REPEAT STRIP_TAC THEN
				CCONTR_TAC THEN
				KNOW_TAC `g (f (std_unif_cont x')) = g x` THEN1
					PROVE_TAC [] THEN
                        	PROVE_TAC [STD_UNIF_CONT_NEQ_0_1],

				PROVE_TAC []]) THEN

			ONCE_ASM_REWRITE_TAC [] THEN	
			RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN]]],


		KNOW_TAC `({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) = x}) \/
                        ~({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) = x})` THEN1
			PROVE_TAC [] THENL [
		KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) = x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) = x})` THEN1
                	PROVE_TAC [] THENL [
	
		KNOW_TAC `{s | f (std_unif_cont s) = x} =
	        	(({s | std_unif_cont s = g x} DIFF
                        {s | std_unif_cont s = 1}) DIFF
                        {s | std_unif_cont s = 0})` THEN1 (
	        	RW_TAC std_ss [SET_EQ_SUBSET] THENL [
	        		FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION, REAL_LT_REFL],

				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                                DIFF_DEF, GSPECIFICATION, REAL_LT_REFL]]) THEN
		ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN],

		KNOW_TAC `{s | f (std_unif_cont s) = x} =
        		{s | std_unif_cont s = 0} UNION
                	({s | f (std_unif_cont s) = x} DIFF
                                        {s | std_unif_cont s = 0})` THEN1 (
        		RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        		FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
        		REWRITE_TAC [EXTENSION] THEN
        		RW_TAC std_ss [GSPECIFICATION] THEN
        		PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		REWRITE_TAC [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `{s | f (std_unif_cont s) = x} DIFF
                        {s | std_unif_cont s = 0} =
                	(({s | std_unif_cont s = g x} DIFF
                        {s | std_unif_cont s = 1}) DIFF
                        {s | std_unif_cont s = 0})` THEN1 (
	        	RW_TAC std_ss [SET_EQ_SUBSET] THENL [
        			FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
				GEN_TAC THEN
				Cases_on `std_unif_cont x' = 1` THEN1
					PROVE_TAC [] THEN
				Cases_on `std_unif_cont x' = 0` THEN1
					PROVE_TAC [] THEN
				RW_TAC std_ss [] THEN
				CCONTR_TAC THEN
				KNOW_TAC `g (f (std_unif_cont x')) = g (f 0)` THEN1
					PROVE_TAC [] THEN
				PROVE_TAC [STD_UNIF_CONT_NEQ_0_1],
			
	
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                                DIFF_DEF, GSPECIFICATION]]) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
        
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN]],
	
		KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) = x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) = x})` THEN1
                	PROVE_TAC [] THENL [

		KNOW_TAC `{s | f (std_unif_cont s) = x} =
        		{s | std_unif_cont s = 1} UNION
                	({s | f (std_unif_cont s) = x} DIFF
                                        {s | std_unif_cont s = 1})` THEN1 (
        		RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        		FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
        		REWRITE_TAC [EXTENSION] THEN
        		RW_TAC std_ss [GSPECIFICATION] THEN
        		PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		SUFF_TAC `{s | f (std_unif_cont s) = f 0} DIFF 
			{s | std_unif_cont s = 1} = 
			{s | std_unif_cont s = 0} DIFF {s | std_unif_cont s = 1}` THEN1
			RW_TAC std_ss [STD_UNIF_CONT_EQ_EVENTS_BERN, EVENTS_DIFF,
				PROB_SPACE_BERN] THEN
		REWRITE_TAC [EXTENSION] THEN
        	GEN_TAC THEN
		FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF, 
                        DIFF_DEF, GSPECIFICATION] THEN
		Cases_on `(std_unif_cont x = 1)` THEN1
			PROVE_TAC [] THEN
		Cases_on `(std_unif_cont x = 0)` THEN1
			PROVE_TAC [] THEN
		EQ_TAC THENL [
			RW_TAC std_ss [] THEN
			CCONTR_TAC THEN
			FULL_SIMP_TAC std_ss [] THEN
			KNOW_TAC `g (f (std_unif_cont x)) = g (f 0)` THEN1
				PROVE_TAC [] THEN
			POP_ASSUM MP_TAC THEN
			RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],
		
			RW_TAC std_ss []],


		KNOW_TAC `{s | f (std_unif_cont s) = x} =
        		({s | std_unif_cont s = 1} UNION
			({s | std_unif_cont s = 0} UNION
                	(({s | f (std_unif_cont s) = x} DIFF
                                        {s | std_unif_cont s = 1}) DIFF 
					{s | std_unif_cont s = 0})))` THEN1 (
			RW_TAC std_ss [UNION_DEF, DIFF_DEF, 
			LEFT_OR_OVER_AND, GSPECIFICATION] THEN
			FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
			REWRITE_TAC [EXTENSION] THEN
			RW_TAC std_ss [GSPECIFICATION] THEN
			PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		REWRITE_TAC [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		REWRITE_TAC [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `({s | f (std_unif_cont s) = x} 
			DIFF {s | std_unif_cont s = 1} 
			DIFF {s | std_unif_cont s = 0}) = 
			(({s | std_unif_cont s = g x} DIFF 
			{s | std_unif_cont s = 1}) DIFF 
			{s | std_unif_cont s = 0})` THEN1 (
			RW_TAC std_ss [DIFF_DEF, EXTENSION] THEN
			PSET_TAC [GSPECIFICATION] THEN
			EQ_TAC THENL [
				REPEAT STRIP_TAC THEN
				CCONTR_TAC THEN
				KNOW_TAC `g (f (std_unif_cont x)) = g (f 0)` THEN1
					PROVE_TAC [] THEN
				POP_ASSUM MP_TAC THEN
				RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],

				RW_TAC std_ss []]) THEN
			
			ONCE_ASM_REWRITE_TAC [] THEN	
			RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN]]]],


		FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
		Cases_on `g x < 1` THENL [
		KNOW_TAC `(f (g x) = x)` THEN1
			PROVE_TAC [] THEN
	
		KNOW_TAC `({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) = x}) \/
                        ~({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) = x})` THEN1
        		PROVE_TAC [] THENL [
		KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) = x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) = x})` THEN1
        		PROVE_TAC [] THENL [


		KNOW_TAC `{s | f (std_unif_cont s) = x} =
        		(({s | std_unif_cont s = g x} DIFF
                        {s | std_unif_cont s = 1}) DIFF
                        {s | std_unif_cont s = 0})` THEN1 (
        		RW_TAC std_ss [SET_EQ_SUBSET] THENL [
        			FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
				GEN_TAC THEN
        			Cases_on `std_unif_cont x''' = 1` THEN1
                			PROVE_TAC [] THEN
                		Cases_on `std_unif_cont x''' = 0` THEN1
                        		PROVE_TAC [] THEN
				RW_TAC std_ss [] THEN
				RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],
                	
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION]]) THEN
			
		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN],

		KNOW_TAC `{s | f (std_unif_cont s) = x} =
        		{s | std_unif_cont s = 0} UNION
                	({s | f (std_unif_cont s) = x} DIFF
                                        {s | std_unif_cont s = 0})` THEN1 (
			RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        		FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
        		REWRITE_TAC [EXTENSION] THEN
        		RW_TAC std_ss [GSPECIFICATION] THEN
        		PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `{s | f (std_unif_cont s) = x} DIFF
                        {s | std_unif_cont s = 0} =
                	(({s | std_unif_cont s = g x} DIFF
                        {s | std_unif_cont s = 1}) DIFF
                        {s | std_unif_cont s = 0})` THEN1 (
        		RW_TAC std_ss [SET_EQ_SUBSET] THENL [
        			FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
				RW_TAC std_ss [] THENL [
                			Cases_on `std_unif_cont x'' = 1` THEN1
                        			PROVE_TAC [] THEN
					RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],
	
					CCONTR_TAC THEN
       					PROVE_TAC []], 
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION]]) THEN
        		
		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN]],







		KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) = x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) = x})` THEN1
        		PROVE_TAC [] THENL [

		KNOW_TAC `{s | f (std_unif_cont s) = x} =
        		{s | std_unif_cont s = 1} UNION
                	({s | f (std_unif_cont s) = x} DIFF
                                        {s | std_unif_cont s = 1})` THEN1 (
        		RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        		FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
        		REWRITE_TAC [EXTENSION] THEN
        		RW_TAC std_ss [GSPECIFICATION] THEN
        		PROVE_TAC []) THEN

		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `{s | f (std_unif_cont s) = x} DIFF
                        {s | std_unif_cont s = 1} =
                	(({s | std_unif_cont s = g x} DIFF
                        {s | std_unif_cont s = 0}) DIFF
                        {s | std_unif_cont s = 1})` THEN1 (
        		RW_TAC std_ss [SET_EQ_SUBSET] THENL [
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
        			RW_TAC std_ss [] THENL [
					Cases_on `std_unif_cont x'' = 0` THEN1
                        			PROVE_TAC [] THEN
                        		RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],

                			CCONTR_TAC THEN
					PROVE_TAC []],
			
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION]]) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN],

		KNOW_TAC `{s | f (std_unif_cont s) = x} =
        		({s | std_unif_cont s = 1} UNION
			({s | std_unif_cont s = 0} UNION
                	(({s | f (std_unif_cont s) = x} DIFF
                                        {s | std_unif_cont s = 1}) DIFF 
					{s | std_unif_cont s = 0})))` THEN1 (
			RW_TAC std_ss [UNION_DEF, DIFF_DEF, 
			LEFT_OR_OVER_AND, GSPECIFICATION] THEN
			FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
			REWRITE_TAC [EXTENSION] THEN
			RW_TAC std_ss [GSPECIFICATION] THEN
			PROVE_TAC []) THEN	
		ONCE_ASM_REWRITE_TAC [] THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `({s | f (std_unif_cont s) = x} 
		DIFF {s | std_unif_cont s = 1} 
		DIFF {s | std_unif_cont s = 0}) = 
		(({s | std_unif_cont s = g x} DIFF 
			{s | std_unif_cont s = 1}) DIFF 
			{s | std_unif_cont s = 0})` THEN1 (
			RW_TAC std_ss [DIFF_DEF, EXTENSION] THEN
			PSET_TAC [GSPECIFICATION] THEN
			EQ_TAC THENL [
				RW_TAC std_ss [] THEN
				RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],

				RW_TAC std_ss []]) THEN
			
		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN]]],


		POP_ASSUM MP_TAC THEN
		REWRITE_TAC [REAL_NOT_LT, REAL_LE_LT] THEN
		RW_TAC std_ss [GSYM REAL_NOT_LE, UB_STD_UNIF_CONT] THEN
		RW_TAC std_ss [REAL_NOT_LE, GSYM REAL_LE_LT] THEN
		POP_ASSUM MP_TAC THEN
		ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
		DISCH_TAC THEN
		KNOW_TAC `f 1 <= x` THEN1
			PROVE_TAC [] THEN
		ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN






		
		KNOW_TAC `({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) = x}) \/
                        ~({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) = x})` THEN1
        		PROVE_TAC [] THENL [
	
		KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) = x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) = x})` THEN1
        		PROVE_TAC [] THENL [
	
		KNOW_TAC `{s | f (std_unif_cont s) = x} =
        	(({s | std_unif_cont s = g x} DIFF
                        {s | std_unif_cont s = 1}) DIFF
                        {s | std_unif_cont s = 0})` THEN1 (
			RW_TAC std_ss [SET_EQ_SUBSET] THENL [
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
				GEN_TAC THEN
				Cases_on `(std_unif_cont x''' = 1)` THEN1
					PROVE_TAC [] THEN
				Cases_on `std_unif_cont x''' = 0` THEN1
					PROVE_TAC [] THEN
				CCONTR_TAC THEN
				KNOW_TAC `g (f (std_unif_cont x''')) = g x` THEN1
                                	PROVE_TAC [] THEN
                        	POP_ASSUM MP_TAC THEN
                        	RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],

				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION]]) THEN
			
		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN],

		KNOW_TAC `{s | f (std_unif_cont s) = x} =
        	{s | std_unif_cont s = 0} UNION
                ({s | f (std_unif_cont s) = x} DIFF
                                        {s | std_unif_cont s = 0})` THEN1 (
				RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        	LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        			FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, 
						IMP_DISJ_THM] THEN
        			REWRITE_TAC [EXTENSION] THEN
        			RW_TAC std_ss [GSPECIFICATION] THEN
        			PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `{s | f (std_unif_cont s) = x} DIFF
                        {s | std_unif_cont s = 0} =
                (({s | std_unif_cont s = g x} DIFF
                        {s | std_unif_cont s = 1}) DIFF
                        {s | std_unif_cont s = 0})` THEN1 (
        		RW_TAC std_ss [SET_EQ_SUBSET] THENL [
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
				GEN_TAC THEN
				Cases_on `(std_unif_cont x'' = 1)` THEN1
					PROVE_TAC [] THEN
				Cases_on `std_unif_cont x'' = 0` THEN1
					PROVE_TAC [] THEN
				RW_TAC std_ss [] THEN
				CCONTR_TAC THEN
				KNOW_TAC `g (f (std_unif_cont x'')) = g x` THEN1
                                	PROVE_TAC [] THEN
                        	POP_ASSUM MP_TAC THEN
                        	RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],


				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION]]) THEN
			
		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN]],


		KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) = x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) = x})` THEN1
        		PROVE_TAC [] THENL [
	
		KNOW_TAC `{s | f (std_unif_cont s) = x} =
        	{s | std_unif_cont s = 1} UNION
                ({s | f (std_unif_cont s) = x} DIFF
                                        {s | std_unif_cont s = 1})` THEN1 (
        		RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        		FULL_SIMP_TAC std_ss [SUBSET_DEF, 
				GSPECIFICATION, IMP_DISJ_THM] THEN
        		REWRITE_TAC [EXTENSION] THEN
        		RW_TAC std_ss [GSPECIFICATION] THEN
        		PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `{s | f (std_unif_cont s) = x} DIFF
                        {s | std_unif_cont s = 1} =
                	(({s | std_unif_cont s = g x} DIFF
                        {s | std_unif_cont s = 0}) DIFF
                        {s | std_unif_cont s = 1})` THEN1 (
        		RW_TAC std_ss [SET_EQ_SUBSET] THENL [
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
				GEN_TAC THEN
				Cases_on `(std_unif_cont x'' = 1)` THEN1
					PROVE_TAC [] THEN
				Cases_on `std_unif_cont x'' = 0` THEN1
					PROVE_TAC [] THEN
				RW_TAC std_ss [] THEN
				CCONTR_TAC THEN
				KNOW_TAC `g (f (std_unif_cont x'')) = g x` THEN1
                                	PROVE_TAC [] THEN
                        	POP_ASSUM MP_TAC THEN
                        	RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1], 


				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        		DIFF_DEF, GSPECIFICATION] THEN
				REPEAT STRIP_TAC ]) THEN

		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN],

		KNOW_TAC `{s | f (std_unif_cont s) = x} =
        	({s | std_unif_cont s = 1} UNION
		({s | std_unif_cont s = 0} UNION
                (({s | f (std_unif_cont s) = x} DIFF
                                        {s | std_unif_cont s = 1}) DIFF 
					{s | std_unif_cont s = 0})))` THEN1 (
			RW_TAC std_ss [UNION_DEF, DIFF_DEF, 
			LEFT_OR_OVER_AND, GSPECIFICATION] THEN
			FULL_SIMP_TAC std_ss [SUBSET_DEF, 
			GSPECIFICATION, IMP_DISJ_THM] THEN
			REWRITE_TAC [EXTENSION] THEN
			RW_TAC std_ss [GSPECIFICATION] THEN
			PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN

		KNOW_TAC `({s | f (std_unif_cont s) = x} 
		DIFF {s | std_unif_cont s = 1} 
		DIFF {s | std_unif_cont s = 0}) = 
			(({s | std_unif_cont s = g x} DIFF 
			{s | std_unif_cont s = 1}) DIFF 
			{s | std_unif_cont s = 0})` THEN1 (
			RW_TAC std_ss [DIFF_DEF, EXTENSION] THEN
			PSET_TAC [GSPECIFICATION] THEN
			Cases_on `(std_unif_cont x'' = 0)` THEN1
				PROVE_TAC [] THEN
			Cases_on `(std_unif_cont x'' = 1)` THEN1
				PROVE_TAC [] THEN
			RW_TAC std_ss [] THEN
			DISJ2_TAC THEN
			CCONTR_TAC THEN
			KNOW_TAC `g (f (std_unif_cont x'')) = g x` THEN1
				PROVE_TAC [REAL_LE_LT] THEN
			POP_ASSUM MP_TAC THEN
			RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1]) THEN
		

		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN]]]]]);

val FN_STD_UNIF_CONT_EVENTS_BERN = store_thm
   ("FN_STD_UNIF_CONT_EVENTS_BERN",
   (--`!f g x. IS_CONT_CDF_FN g /\
	(INV_CDF_FN f g) ==>
	{s | f (std_unif_cont s) <= x} IN events bern`--),
	REPEAT STRIP_TAC THEN
POP_ASSUM MP_TAC THEN
KNOW_TAC `(!x. 0 <= g x /\ g x <= 1)` THEN1
        PROVE_TAC [LIM_POS1_NEG0_IMP_GE0_LE1] THEN
UNDISCH_TAC (--`IS_CONT_CDF_FN g`--) THEN
DISCH_TAC THEN

KNOW_TAC `(?y. 0 < g y /\ g y < 1)` THEN1
        PROVE_TAC [CONT_CDF_EXISTS_GT0_LT1] THEN
STRIP_TAC THEN
FULL_SIMP_TAC std_ss [INV_CDF_FN_def, IS_CONT_CDF_FN_def] THEN

	KNOW_TAC `!x. 0 < x /\ x < 1 ==> (g (f x) = x)` THEN1 (
        	POP_ASSUM (MP_TAC o Q.SPEC `y:real`) THEN
        	PROVE_TAC []) THEN
	Cases_on `g x <= 0` THENL [
        	POP_ASSUM MP_TAC THEN
        	RW_TAC std_ss [REAL_LE_LT] THEN1
                	PROVE_TAC [real_lt] THEN
        	KNOW_TAC `x <= f 0` THEN1
                	PROVE_TAC [] THEN
        	UNDISCH_TAC (--`(x:real) <= (f:real -> real) (0:real)`--) THEN
        	REWRITE_TAC [REAL_LE_LT] THEN
        	REPEAT STRIP_TAC THENL [
                	RW_TAC std_ss [GSYM REAL_LE_LT] THEN
		KNOW_TAC `({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) <= x}) \/
                        ~({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) <= x})` THEN1
			PROVE_TAC [] THENL [
		KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x})` THEN1
                	PROVE_TAC [] THENL [
	
		KNOW_TAC `{s | f (std_unif_cont s) <= x} =
	        (({s | std_unif_cont s <= g x} DIFF
                        {s | std_unif_cont s = 1}) DIFF
                        {s | std_unif_cont s = 0})` THEN1 (
	        	RW_TAC std_ss [SET_EQ_SUBSET] THENL [
	        		FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
	        		GEN_TAC THEN
        			Cases_on `std_unif_cont x''' = 1` THEN1
                			PROVE_TAC [real_lte] THEN
				Cases_on `std_unif_cont x''' = 0` THEN1
					PROVE_TAC [real_lte] THEN
				RW_TAC std_ss [] THEN
				KNOW_TAC `g (f (std_unif_cont x''')) <= g x` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				KNOW_TAC `g (f (std_unif_cont x''')) = (std_unif_cont x''')` THEN1
					PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
				PROVE_TAC [],

				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                                DIFF_DEF, GSPECIFICATION] THEN
				GEN_TAC THEN
				Cases_on `std_unif_cont x''' = 1` THEN1
                                	PROVE_TAC [real_lte] THEN
                        	Cases_on `std_unif_cont x''' = 0` THEN1
                                	PROVE_TAC [real_lte] THEN
                        	RW_TAC std_ss [] THEN
				CCONTR_TAC THEN
				FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
				KNOW_TAC `g x <= g (f (std_unif_cont x'''))` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				KNOW_TAC `g (f (std_unif_cont x''')) = (std_unif_cont x''')` THEN1
                                	PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
				PROVE_TAC [REAL_LE_ANTISYM]]) THEN

		ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN],

		KNOW_TAC `{s | f (std_unif_cont s) <= x} =
        		{s | std_unif_cont s = 0} UNION
                	({s | f (std_unif_cont s) <= x} DIFF
                                        {s | std_unif_cont s = 0})` THEN1 (
        		RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        		FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
        		REWRITE_TAC [EXTENSION] THEN
        		RW_TAC std_ss [GSPECIFICATION] THEN
        		POP_ASSUM (MP_TAC o Q.SPEC `x''`) THEN
        		PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `{s | f (std_unif_cont s) <= x} DIFF
                        {s | std_unif_cont s = 0} =
                	(({s | std_unif_cont s <= g x} DIFF
                        {s | std_unif_cont s = 1}) DIFF
                        {s | std_unif_cont s = 0})` THEN1 (
	        	RW_TAC std_ss [SET_EQ_SUBSET] THENL [
        			FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
				GEN_TAC THEN
				Cases_on `std_unif_cont x'' = 1` THEN1
					PROVE_TAC [real_lt] THEN
				Cases_on `std_unif_cont x'' = 0` THEN1
					PROVE_TAC [real_lt] THEN
				RW_TAC std_ss [] THEN
				KNOW_TAC `g (f (std_unif_cont x'')) <= g x` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				KNOW_TAC `g (f (std_unif_cont x'')) = (std_unif_cont x'')` THEN1
					PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
				PROVE_TAC [],
	
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                                	DIFF_DEF, GSPECIFICATION] THEN
                        	GEN_TAC THEN
                        	Cases_on `std_unif_cont x'' = 1` THEN1
                                	PROVE_TAC [real_lt] THEN
                        	Cases_on `std_unif_cont x'' = 0` THEN1
                                	PROVE_TAC [real_lt] THEN
                        	RW_TAC std_ss [] THEN
				CCONTR_TAC THEN
                        	FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
                        	KNOW_TAC `g x <= g (f (std_unif_cont x''))` THEN1
                                	PROVE_TAC [REAL_LE_LT] THEN
                        	KNOW_TAC `g (f (std_unif_cont x'')) = (std_unif_cont x'')` THEN1
                                	PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
                        	PROVE_TAC [REAL_LE_ANTISYM]]) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
        	POP_ASSUM K_TAC THEN
        	POP_ASSUM K_TAC THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN]],
	
		KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x})` THEN1
                	PROVE_TAC [] THENL [

		KNOW_TAC `{s | f (std_unif_cont s) <= x} =
        		{s | std_unif_cont s = 1} UNION
                	({s | f (std_unif_cont s) <= x} DIFF
                                        {s | std_unif_cont s = 1})` THEN1 (
        		RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        		FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
        		REWRITE_TAC [EXTENSION] THEN
        		RW_TAC std_ss [GSPECIFICATION] THEN
        		PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `{s | f (std_unif_cont s) <= x} DIFF
                        {s | std_unif_cont s = 1} =
                	(({s | std_unif_cont s <= g x} DIFF
                        {s | std_unif_cont s = 0}) DIFF
                        {s | std_unif_cont s = 1})` THEN1 (
	        	RW_TAC std_ss [SET_EQ_SUBSET] THENL [
        			FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        		DIFF_DEF, GSPECIFICATION] THEN
				GEN_TAC THEN
				Cases_on `std_unif_cont x' = 1` THEN1
					PROVE_TAC [real_lt] THEN
				Cases_on `std_unif_cont x' = 0` THEN1
					PROVE_TAC [real_lt] THEN
				RW_TAC std_ss [] THEN
				KNOW_TAC `g (f (std_unif_cont x')) <= g x` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				KNOW_TAC `g (f (std_unif_cont x')) = (std_unif_cont x')` THEN1
					PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
				PROVE_TAC [],
	
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                                	DIFF_DEF, GSPECIFICATION] THEN
                        	GEN_TAC THEN
                        	Cases_on `std_unif_cont x' = 1` THEN1
                                	PROVE_TAC [real_lt] THEN
                        	Cases_on `std_unif_cont x' = 0` THEN1
                                	PROVE_TAC [real_lt] THEN
                        	RW_TAC std_ss [] THEN
				CCONTR_TAC THEN
                        	FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
                        	KNOW_TAC `g x <= g (f (std_unif_cont x'))` THEN1
                                	PROVE_TAC [REAL_LE_LT] THEN
                        	KNOW_TAC `g (f (std_unif_cont x')) = (std_unif_cont x')` THEN1
                                	PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
                        	PROVE_TAC [REAL_LE_ANTISYM]]) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
        	POP_ASSUM K_TAC THEN
        	POP_ASSUM K_TAC THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN],

		KNOW_TAC `{s | f (std_unif_cont s) <= x} =
        		({s | std_unif_cont s = 1} UNION
			({s | std_unif_cont s = 0} UNION
                	(({s | f (std_unif_cont s) <= x} DIFF
                                        {s | std_unif_cont s = 1}) DIFF 
					{s | std_unif_cont s = 0})))` THEN1 (
			RW_TAC std_ss [UNION_DEF, DIFF_DEF, 
			LEFT_OR_OVER_AND, GSPECIFICATION] THEN
			FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
			REWRITE_TAC [EXTENSION] THEN
			RW_TAC std_ss [GSPECIFICATION] THEN
			PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `({s | f (std_unif_cont s) <= x} 
			DIFF {s | std_unif_cont s = 1} 
			DIFF {s | std_unif_cont s = 0}) = 
			(({s | std_unif_cont s <= g x} DIFF 
			{s | std_unif_cont s = 1}) DIFF 
			{s | std_unif_cont s = 0})` THEN1 (
			RW_TAC std_ss [DIFF_DEF, EXTENSION] THEN
			PSET_TAC [GSPECIFICATION] THEN
			EQ_TAC THENL [
				RW_TAC std_ss [] THEN
				KNOW_TAC `g (f (std_unif_cont x')) <= g x` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				POP_ASSUM MP_TAC THEN
				RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],

				RW_TAC std_ss [] THEN
				CCONTR_TAC THEN
				FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
				KNOW_TAC `g x <= g (f (std_unif_cont x'))` THEN1
					PROVE_TAC [] THEN
				KNOW_TAC `g (f (std_unif_cont x')) = (std_unif_cont x')` THEN1
                                	PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
                        	PROVE_TAC [REAL_LE_ANTISYM]]) THEN
			ONCE_ASM_REWRITE_TAC [] THEN	
			RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN]]],





		REWRITE_TAC [GSYM REAL_LE_LT] THEN
		KNOW_TAC `({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) <= x}) \/
                        ~({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) <= x})` THEN1
			PROVE_TAC [] THENL [
		KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x})` THEN1
                	PROVE_TAC [] THENL [
	
		KNOW_TAC `{s | f (std_unif_cont s) <= x} =
	        (({s | std_unif_cont s <= g x} DIFF
                        {s | std_unif_cont s = 1}) DIFF
                        {s | std_unif_cont s = 0})` THEN1 (
	        	RW_TAC std_ss [SET_EQ_SUBSET] THENL [
	        		FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION, REAL_LT_REFL],

				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                                DIFF_DEF, GSPECIFICATION, REAL_LT_REFL]]) THEN
		ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN],

		KNOW_TAC `{s | f (std_unif_cont s) <= x} =
        		{s | std_unif_cont s = 0} UNION
                	({s | f (std_unif_cont s) <= x} DIFF
                                        {s | std_unif_cont s = 0})` THEN1 (
        		RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        		FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
        		REWRITE_TAC [EXTENSION] THEN
        		RW_TAC std_ss [GSPECIFICATION] THEN
        		PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		REWRITE_TAC [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `{s | f (std_unif_cont s) <= x} DIFF
                        {s | std_unif_cont s = 0} =
                	(({s | std_unif_cont s <= g x} DIFF
                        {s | std_unif_cont s = 1}) DIFF
                        {s | std_unif_cont s = 0})` THEN1 (
	        	RW_TAC std_ss [SET_EQ_SUBSET] THENL [
        			FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        		DIFF_DEF, GSPECIFICATION] THEN
				GEN_TAC THEN
				Cases_on `std_unif_cont x' = 1` THEN1
					PROVE_TAC [real_lt] THEN
				Cases_on `std_unif_cont x' = 0` THEN1
					PROVE_TAC [real_lt] THEN
				RW_TAC std_ss [] THEN
				KNOW_TAC `g (f (std_unif_cont x')) <= g (f 0)` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				KNOW_TAC `g (f (std_unif_cont x')) = (std_unif_cont x')` THEN1
					PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
				PROVE_TAC [],
	
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                                	DIFF_DEF, GSPECIFICATION] THEN
                        	GEN_TAC THEN
                        	Cases_on `std_unif_cont x' = 1` THEN1
                                	PROVE_TAC [real_lt] THEN
                        	Cases_on `std_unif_cont x' = 0` THEN1
                                	PROVE_TAC [real_lt] THEN
                        	RW_TAC std_ss [] THEN
				CCONTR_TAC THEN
                        	FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
                        	KNOW_TAC `g (f 0) <= g (f (std_unif_cont x'))` THEN1
                                	PROVE_TAC [REAL_LE_LT] THEN
                        	KNOW_TAC `g (f (std_unif_cont x')) = (std_unif_cont x')` THEN1
                                	PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
                        	PROVE_TAC [REAL_LE_ANTISYM]]) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
        	POP_ASSUM K_TAC THEN
        	POP_ASSUM K_TAC THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN]],
	
		KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x})` THEN1
                	PROVE_TAC [] THENL [

		KNOW_TAC `{s | f (std_unif_cont s) <= x} =
        		{s | std_unif_cont s = 1} UNION
                	({s | f (std_unif_cont s) <= x} DIFF
                                        {s | std_unif_cont s = 1})` THEN1 (
        		RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        		FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
        		REWRITE_TAC [EXTENSION] THEN
        		RW_TAC std_ss [GSPECIFICATION] THEN
        		PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		SUFF_TAC `{s | f (std_unif_cont s) <= f 0} DIFF 
			{s | std_unif_cont s = 1} = 
			{s | std_unif_cont s = 0} DIFF {s | std_unif_cont s = 1}` THEN1
			RW_TAC std_ss [STD_UNIF_CONT_EQ_EVENTS_BERN, EVENTS_DIFF,
				PROB_SPACE_BERN] THEN
		REWRITE_TAC [EXTENSION] THEN
        	GEN_TAC THEN
		FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF, 
                        DIFF_DEF, GSPECIFICATION] THEN
		Cases_on `(std_unif_cont x = 1)` THEN1
			PROVE_TAC [] THEN
		Cases_on `(std_unif_cont x = 0)` THEN1
			PROVE_TAC [] THEN
		EQ_TAC THENL [
			RW_TAC std_ss [] THEN
			CCONTR_TAC THEN
			FULL_SIMP_TAC std_ss [] THEN
			KNOW_TAC `g (f (std_unif_cont x)) <= g (f 0)` THEN1
				PROVE_TAC [REAL_LE_LT] THEN
			POP_ASSUM MP_TAC THEN
			RW_TAC std_ss [REAL_NOT_LE, STD_UNIF_CONT_NEQ_0_1],
		
			RW_TAC std_ss []], 


		KNOW_TAC `{s | f (std_unif_cont s) <= x} =
        		({s | std_unif_cont s = 1} UNION
			({s | std_unif_cont s = 0} UNION
                	(({s | f (std_unif_cont s) <= x} DIFF
                                        {s | std_unif_cont s = 1}) DIFF 
					{s | std_unif_cont s = 0})))` THEN1 (
			RW_TAC std_ss [UNION_DEF, DIFF_DEF, 
			LEFT_OR_OVER_AND, GSPECIFICATION] THEN
			FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
			REWRITE_TAC [EXTENSION] THEN
			RW_TAC std_ss [GSPECIFICATION] THEN
			PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		REWRITE_TAC [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		REWRITE_TAC [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `({s | f (std_unif_cont s) <= x} 
			DIFF {s | std_unif_cont s = 1} 
			DIFF {s | std_unif_cont s = 0}) = 
			(({s | std_unif_cont s <= g x} DIFF 
			{s | std_unif_cont s = 1}) DIFF 
			{s | std_unif_cont s = 0})` THEN1 (
			RW_TAC std_ss [DIFF_DEF, EXTENSION] THEN1
			PSET_TAC [GSPECIFICATION] THEN
			EQ_TAC THENL [
				RW_TAC std_ss [] THEN
				KNOW_TAC `g (f (std_unif_cont x)) <= g (f 0)` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				POP_ASSUM MP_TAC THEN
				RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],

				RW_TAC std_ss [] THEN
				CCONTR_TAC THEN
				FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
				KNOW_TAC `g (f 0) <= g (f (std_unif_cont x))` THEN1
					PROVE_TAC [] THEN
				KNOW_TAC `g (f (std_unif_cont x)) = (std_unif_cont x)` THEN1
                                	PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
                        	PROVE_TAC [REAL_LE_ANTISYM]]) THEN
			ONCE_ASM_REWRITE_TAC [] THEN	
			RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN]]]],


		FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
		Cases_on `g x < 1` THENL [
		KNOW_TAC `(f (g x) = x)` THEN1
			PROVE_TAC [] THEN
	
		KNOW_TAC `({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) <= x}) \/
                        ~({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) <= x})` THEN1
        		PROVE_TAC [] THENL [
		KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x})` THEN1
        		PROVE_TAC [] THENL [


		KNOW_TAC `{s | f (std_unif_cont s) <= x} =
        		(({s | std_unif_cont s <= g x} DIFF
                        {s | std_unif_cont s = 1}) DIFF
                        {s | std_unif_cont s = 0})` THEN1 (
        		RW_TAC std_ss [SET_EQ_SUBSET] THENL [
        			FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        		DIFF_DEF, GSPECIFICATION] THEN
				GEN_TAC THEN
        			Cases_on `std_unif_cont x''' = 1` THEN1
                			PROVE_TAC [real_lte] THEN
                		Cases_on `std_unif_cont x''' = 0` THEN1
                        		PROVE_TAC [real_lte] THEN
				RW_TAC std_ss [] THEN
                		KNOW_TAC `g (f (std_unif_cont x''')) <= g x` THEN1
                                	PROVE_TAC [REAL_LE_LT] THEN
                		POP_ASSUM MP_TAC THEN
                		RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],

				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        		DIFF_DEF, GSPECIFICATION] THEN
				RW_TAC std_ss [] THEN
				CCONTR_TAC THEN
				FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
				KNOW_TAC `g x <= g (f (std_unif_cont x'''))` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				KNOW_TAC `g (f (std_unif_cont x''')) = std_unif_cont x'''` THEN1
					RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1] THEN
				FULL_SIMP_TAC std_ss [] THEN
				KNOW_TAC ` g x = std_unif_cont x'''` THEN1
					PROVE_TAC [GSYM REAL_LE_ANTISYM] THEN
				KNOW_TAC `f (g x) = f (std_unif_cont x''')` THEN1
					PROVE_TAC [] THEN
				POP_ASSUM MP_TAC THEN
				RW_TAC std_ss [REAL_NE_LT_GT]]) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN],

		KNOW_TAC `{s | f (std_unif_cont s) <= x} =
        		{s | std_unif_cont s = 0} UNION
                	({s | f (std_unif_cont s) <= x} DIFF
                                        {s | std_unif_cont s = 0})` THEN1 (
			RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        		FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
        		REWRITE_TAC [EXTENSION] THEN
        		RW_TAC std_ss [GSPECIFICATION] THEN
			POP_ASSUM (MP_TAC o Q.SPEC `x''`) THEN
        		PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `{s | f (std_unif_cont s) <= x} DIFF
                        {s | std_unif_cont s = 0} =
                	(({s | std_unif_cont s <= g x} DIFF
                        {s | std_unif_cont s = 1}) DIFF
                        {s | std_unif_cont s = 0})` THEN1 (
        		RW_TAC std_ss [SET_EQ_SUBSET] THENL [
        			FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        		DIFF_DEF, GSPECIFICATION] THEN
				RW_TAC std_ss [] THENL [
                			Cases_on `std_unif_cont x'' = 1` THEN1
                        			PROVE_TAC [real_lt] THEN
                        		KNOW_TAC `g (f (std_unif_cont x'')) <= g x` THEN1
                                		PROVE_TAC [REAL_LE_LT] THEN
					POP_ASSUM MP_TAC THEN
					RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],
	
					CCONTR_TAC THEN
       					PROVE_TAC [real_lt]], 
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
        			RW_TAC std_ss [] THEN
				CCONTR_TAC THEN
				FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
				KNOW_TAC `g x <= g (f (std_unif_cont x''))` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				KNOW_TAC `g (f (std_unif_cont x'')) = std_unif_cont x''` THEN1
					RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1] THEN
				FULL_SIMP_TAC std_ss [] THEN
				KNOW_TAC ` g x = std_unif_cont x''` THEN1
					PROVE_TAC [GSYM REAL_LE_ANTISYM] THEN
				KNOW_TAC `f (g x) = f (std_unif_cont x'')` THEN1
					PROVE_TAC [] THEN
				POP_ASSUM MP_TAC THEN
				RW_TAC std_ss [REAL_NE_LT_GT]]) THEN

		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN]],

		KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x})` THEN1
        		PROVE_TAC [] THENL [

		KNOW_TAC `{s | f (std_unif_cont s) <= x} =
        		{s | std_unif_cont s = 1} UNION
                	({s | f (std_unif_cont s) <= x} DIFF
                                        {s | std_unif_cont s = 1})` THEN1 (
        		RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        		FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
        		REWRITE_TAC [EXTENSION] THEN
        		RW_TAC std_ss [GSPECIFICATION] THEN
        		PROVE_TAC []) THEN

		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `{s | f (std_unif_cont s) <= x} DIFF
                        {s | std_unif_cont s = 1} =
                	(({s | std_unif_cont s <= g x} DIFF
                        {s | std_unif_cont s = 0}) DIFF
                        {s | std_unif_cont s = 1})` THEN1 (
        		RW_TAC std_ss [SET_EQ_SUBSET] THENL [
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        		DIFF_DEF, GSPECIFICATION] THEN
        			RW_TAC std_ss [] THENL [
					Cases_on `std_unif_cont x'' = 0` THEN1
                        			PROVE_TAC [real_lt] THEN
                        		KNOW_TAC `g (f (std_unif_cont x''))
                                                                <= g x` THEN1
                                		PROVE_TAC [REAL_LE_LT] THEN
                        		POP_ASSUM MP_TAC THEN
                        		RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],

                			CCONTR_TAC THEN
					PROVE_TAC [real_lt]],
			
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
        			RW_TAC std_ss [] THEN
				CCONTR_TAC THEN
				FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
				KNOW_TAC `g x <= g (f (std_unif_cont x''))` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				KNOW_TAC `g (f (std_unif_cont x'')) = std_unif_cont x''` THEN1
					RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1] THEN
				FULL_SIMP_TAC std_ss [] THEN
				KNOW_TAC ` g x = std_unif_cont x''` THEN1
					PROVE_TAC [GSYM REAL_LE_ANTISYM] THEN
				KNOW_TAC `f (g x) = f (std_unif_cont x'')` THEN1
					PROVE_TAC [] THEN
				POP_ASSUM MP_TAC THEN
				RW_TAC std_ss [REAL_NE_LT_GT]]) THEN

		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN],

		KNOW_TAC `{s | f (std_unif_cont s) <= x} =
        		({s | std_unif_cont s = 1} UNION
			({s | std_unif_cont s = 0} UNION
                	(({s | f (std_unif_cont s) <= x} DIFF
                                        {s | std_unif_cont s = 1}) DIFF 
					{s | std_unif_cont s = 0})))` THEN1 (
			RW_TAC std_ss [UNION_DEF, DIFF_DEF, 
			LEFT_OR_OVER_AND, GSPECIFICATION] THEN
			FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IMP_DISJ_THM] THEN
			REWRITE_TAC [EXTENSION] THEN
			RW_TAC std_ss [GSPECIFICATION] THEN
			PROVE_TAC []) THEN	
		ONCE_ASM_REWRITE_TAC [] THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `({s | f (std_unif_cont s) <= x} 
			DIFF {s | std_unif_cont s = 1} 
			DIFF {s | std_unif_cont s = 0}) = 
			(({s | std_unif_cont s <= g x} DIFF 
			{s | std_unif_cont s = 1}) DIFF 
			{s | std_unif_cont s = 0})` THEN1 (
			RW_TAC std_ss [DIFF_DEF, EXTENSION] THEN
			PSET_TAC [GSPECIFICATION] THEN
			EQ_TAC THENL [
				RW_TAC std_ss [] THEN
				KNOW_TAC `g (f (std_unif_cont x')) <= g x` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				POP_ASSUM MP_TAC THEN
				RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],

				RW_TAC std_ss [] THEN
				CCONTR_TAC THEN
				FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
				KNOW_TAC `g x <= g (f (std_unif_cont x'))` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				KNOW_TAC `g (f (std_unif_cont x')) = std_unif_cont x'` THEN1
					RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1] THEN
				FULL_SIMP_TAC std_ss [] THEN
				KNOW_TAC ` g x = std_unif_cont x'` THEN1
					PROVE_TAC [GSYM REAL_LE_ANTISYM] THEN
				KNOW_TAC `f (g x) = f (std_unif_cont x')` THEN1
					PROVE_TAC [] THEN
				POP_ASSUM MP_TAC THEN
				RW_TAC std_ss [REAL_NE_LT_GT]]) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN]]],


		POP_ASSUM MP_TAC THEN
		REWRITE_TAC [REAL_NOT_LT, REAL_LE_LT] THEN
		RW_TAC std_ss [GSYM REAL_NOT_LE, UB_STD_UNIF_CONT] THEN
		RW_TAC std_ss [REAL_NOT_LE, GSYM REAL_LE_LT] THEN
		POP_ASSUM MP_TAC THEN
		ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
		DISCH_TAC THEN
		KNOW_TAC `f 1 <= x` THEN1
			PROVE_TAC [] THEN
		
		KNOW_TAC `({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) <= x}) \/
                        ~({s | std_unif_cont s = 1} SUBSET
                {s | f (std_unif_cont s) <= x})` THEN1
        		PROVE_TAC [] THENL [
	
		KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x})` THEN1
        		PROVE_TAC [] THENL [
	
		KNOW_TAC `{s | f (std_unif_cont s) <= x} =
        	(({s | std_unif_cont s <= g x} DIFF
                        {s | std_unif_cont s = 1}) DIFF
                        {s | std_unif_cont s = 0})` THEN1 (
			RW_TAC std_ss [SET_EQ_SUBSET] THENL [
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
				GEN_TAC THEN
				Cases_on `(std_unif_cont x''' = 1)` THEN1
					PROVE_TAC [real_lte] THEN
				Cases_on `std_unif_cont x''' = 0` THEN1
					PROVE_TAC [real_lte] THEN
				RW_TAC std_ss [] THEN
				KNOW_TAC `g (f (std_unif_cont x'''))
                                                                <= g x` THEN1
                                	PROVE_TAC [REAL_LE_LT] THEN
                        	POP_ASSUM MP_TAC THEN
                        	RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],

				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
				RW_TAC std_ss [] THEN
				CCONTR_TAC THEN
				FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
				KNOW_TAC `g x <= g (f (std_unif_cont x'''))` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				KNOW_TAC `g (f (std_unif_cont x''')) = std_unif_cont x'''` THEN1
					PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
				FULL_SIMP_TAC std_ss [] THEN
				KNOW_TAC ` g x = std_unif_cont x'''` THEN1
					PROVE_TAC [GSYM REAL_LE_ANTISYM] THEN
				PROVE_TAC []]) THEN
	
		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN],

		KNOW_TAC `{s | f (std_unif_cont s) <= x} =
        		{s | std_unif_cont s = 0} UNION
                	({s | f (std_unif_cont s) <= x} DIFF
                                        {s | std_unif_cont s = 0})` THEN1 (
				RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        	LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        			FULL_SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, 
						IMP_DISJ_THM] THEN
        			REWRITE_TAC [EXTENSION] THEN
        			RW_TAC std_ss [GSPECIFICATION] THEN
				POP_ASSUM (MP_TAC o Q.SPEC `x''`) THEN
        			PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `{s | f (std_unif_cont s) <= x} DIFF
                        {s | std_unif_cont s = 0} =
                	(({s | std_unif_cont s <= g x} DIFF
                        {s | std_unif_cont s = 1}) DIFF
                        {s | std_unif_cont s = 0})` THEN1 (
        		RW_TAC std_ss [SET_EQ_SUBSET] THENL [
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
				GEN_TAC THEN
				Cases_on `(std_unif_cont x'' = 1)` THEN1
					PROVE_TAC [real_lte] THEN
				Cases_on `std_unif_cont x'' = 0` THEN1
					PROVE_TAC [real_lte] THEN
				RW_TAC std_ss [] THEN
				KNOW_TAC `g (f (std_unif_cont x''))
                                                                <= g x` THEN1
                                	PROVE_TAC [REAL_LE_LT] THEN
                        	POP_ASSUM MP_TAC THEN
                        	RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],


				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        		DIFF_DEF, GSPECIFICATION] THEN
				RW_TAC std_ss [] THEN
				CCONTR_TAC THEN
				FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
				KNOW_TAC `g x <= g (f (std_unif_cont x''))` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				KNOW_TAC `g (f (std_unif_cont x'')) = 
						std_unif_cont x''` THEN1
					PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
				FULL_SIMP_TAC std_ss [] THEN
				KNOW_TAC ` g x = std_unif_cont x''` THEN1
					PROVE_TAC [GSYM REAL_LE_ANTISYM] THEN
				PROVE_TAC []]) THEN

		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN]],


		KNOW_TAC `({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x}) \/
                        ~({s | std_unif_cont s = 0} SUBSET
                {s | f (std_unif_cont s) <= x})` THEN1
        		PROVE_TAC [] THENL [
	
		KNOW_TAC `{s | f (std_unif_cont s) <= x} =
        		{s | std_unif_cont s = 1} UNION
                	({s | f (std_unif_cont s) <= x} DIFF
                                        {s | std_unif_cont s = 1})` THEN1 (
        		RW_TAC std_ss [UNION_DEF, DIFF_DEF,
                        LEFT_OR_OVER_AND, GSPECIFICATION] THEN
        		FULL_SIMP_TAC std_ss [SUBSET_DEF, 
				GSPECIFICATION, IMP_DISJ_THM] THEN
        		REWRITE_TAC [EXTENSION] THEN
        		RW_TAC std_ss [GSPECIFICATION] THEN
        		PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		KNOW_TAC `{s | f (std_unif_cont s) <= x} DIFF
                        {s | std_unif_cont s = 1} =
                	(({s | std_unif_cont s <= g x} DIFF
                        {s | std_unif_cont s = 0}) DIFF
                        {s | std_unif_cont s = 1})` THEN1 (
        		RW_TAC std_ss [SET_EQ_SUBSET] THENL [
				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        	DIFF_DEF, GSPECIFICATION] THEN
				GEN_TAC THEN
				Cases_on `(std_unif_cont x'' = 1)` THEN1
					PROVE_TAC [real_lte] THEN
				Cases_on `std_unif_cont x'' = 0` THEN1
					PROVE_TAC [real_lte] THEN
				RW_TAC std_ss [] THEN
				KNOW_TAC `g (f (std_unif_cont x''))
                                                                <= g x` THEN1
                                	PROVE_TAC [REAL_LE_LT] THEN
                        	POP_ASSUM MP_TAC THEN
                        	RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],


				FULL_SIMP_TAC std_ss [GSYM real_lt, SUBSET_DEF,
                        		DIFF_DEF, GSPECIFICATION] THEN
				RW_TAC std_ss [] THEN
				CCONTR_TAC THEN
				FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
				KNOW_TAC `g x <= g (f (std_unif_cont x''))` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				KNOW_TAC `g (f (std_unif_cont x'')) = 
						std_unif_cont x''` THEN1
					PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
				FULL_SIMP_TAC std_ss [] THEN
				KNOW_TAC ` g x = std_unif_cont x''` THEN1
					PROVE_TAC [GSYM REAL_LE_ANTISYM] THEN
				PROVE_TAC []]) THEN

		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN],

		KNOW_TAC `{s | f (std_unif_cont s) <= x} =
        		({s | std_unif_cont s = 1} UNION
			({s | std_unif_cont s = 0} UNION
                	(({s | f (std_unif_cont s) <= x} DIFF
                                        {s | std_unif_cont s = 1}) DIFF 
					{s | std_unif_cont s = 0})))` THEN1 (
			RW_TAC std_ss [UNION_DEF, DIFF_DEF, 
			LEFT_OR_OVER_AND, GSPECIFICATION] THEN
			FULL_SIMP_TAC std_ss [SUBSET_DEF, 
			GSPECIFICATION, IMP_DISJ_THM] THEN
			REWRITE_TAC [EXTENSION] THEN
			RW_TAC std_ss [GSPECIFICATION] THEN
			PROVE_TAC []) THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN] THEN

		KNOW_TAC `({s | f (std_unif_cont s) <= x} 
			DIFF {s | std_unif_cont s = 1} 
			DIFF {s | std_unif_cont s = 0}) = 
			(({s | std_unif_cont s <= g x} DIFF 
			{s | std_unif_cont s = 1}) DIFF 
			{s | std_unif_cont s = 0})` THEN1 (
			RW_TAC std_ss [DIFF_DEF, EXTENSION] THEN
			PSET_TAC [GSPECIFICATION] THEN
			EQ_TAC THENL [
				RW_TAC std_ss [] THEN
				KNOW_TAC `g (f (std_unif_cont x')) <= g x` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				POP_ASSUM MP_TAC THEN
				RW_TAC std_ss [STD_UNIF_CONT_NEQ_0_1],
		
			RW_TAC std_ss [] THEN
			CCONTR_TAC THEN
			FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
			KNOW_TAC `g x <= g (f (std_unif_cont x'))` THEN1
				PROVE_TAC [REAL_LE_LT] THEN
			KNOW_TAC `g (f (std_unif_cont x')) = 
					std_unif_cont x'` THEN1
				PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
			FULL_SIMP_TAC std_ss [] THEN
			KNOW_TAC ` g x = std_unif_cont x'` THEN1
				PROVE_TAC [GSYM REAL_LE_ANTISYM] THEN
			PROVE_TAC []]) THEN

		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EVENTS_BERN,
                        EVENTS_DIFF, STD_UNIF_CONT_EQ_EVENTS_BERN]]]]]);


val ITM_HELPER = store_thm
    ("ITM_HELPER",
    (--`!f g x. IS_CONT_CDF_FN g /\
		(INV_CDF_FN f g) ==>
        (prob bern  {s | f (std_unif_cont s) <= x} =
                prob bern  {s | std_unif_cont s <= g x})`--),
REPEAT STRIP_TAC THEN
POP_ASSUM MP_TAC THEN
KNOW_TAC `(!x. 0 <= g x /\ g x <= 1)` THEN1
        PROVE_TAC [LIM_POS1_NEG0_IMP_GE0_LE1] THEN
UNDISCH_TAC (--`IS_CONT_CDF_FN g`--) THEN
DISCH_TAC THEN

KNOW_TAC `(?y. 0 < g y /\ g y < 1)` THEN1
        PROVE_TAC [CONT_CDF_EXISTS_GT0_LT1] THEN
STRIP_TAC THEN
FULL_SIMP_TAC std_ss [INV_CDF_FN_def, IS_CONT_CDF_FN_def] THEN
	
KNOW_TAC `!x. 0 < x /\ x < 1 ==> (g (f x) = x)` THEN1 (
        	POP_ASSUM (MP_TAC o Q.SPEC `y:real`) THEN
        	PROVE_TAC []) THEN
	KNOW_TAC `prob bern  {s | f (std_unif_cont s) <= x} =
                prob bern  ({s | f (std_unif_cont s) <= x}
                DIFF {s | std_unif_cont s = 1} DIFF {s | std_unif_cont s = 0})` THEN1 (
		MATCH_MP_TAC SET_DIFF_STD_UNIF_CONT_0_1 THEN
		MATCH_MP_TAC FN_STD_UNIF_CONT_EVENTS_BERN THEN 
		EXISTS_TAC (--`g:real -> real`--) THEN
		RW_TAC std_ss [INV_CDF_FN_def, IS_CONT_CDF_FN_def] THEN
		EXISTS_TAC (--`y:real`--) THEN
		PROVE_TAC []) THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	Cases_on `g x <= 0` THENL [
        	POP_ASSUM MP_TAC THEN
        	RW_TAC std_ss [REAL_LE_LT] THEN1
                	PROVE_TAC [real_lt] THEN
		KNOW_TAC `x <= f 0` THEN1
                	PROVE_TAC [] THEN
        	UNDISCH_TAC (--`(x:real) <= (f:real -> real) (0:real)`--) THEN
        	REWRITE_TAC [REAL_LE_LT] THEN
        	REPEAT STRIP_TAC THENL [
			RW_TAC std_ss [GSYM REAL_LE_LT] THEN
			KNOW_TAC `prob bern {s | std_unif_cont s <= 0} = 
					prob bern {s | F}` THEN1
				RW_TAC std_ss [REAL_LE_LT, GSYM REAL_NOT_LE, 
					LB_STD_UNIF_CONT, PMF_STD_UNIF_CONT, GSPEC_F,
					PROB_BERN_EMPTY] THEN
			ASM_REWRITE_TAC [] THEN
			
			KNOW_TAC `prob bern {s | F} =
                		prob bern ({s | F}
                		DIFF {s | std_unif_cont s = 1} DIFF {s | std_unif_cont s = 0})` THEN1 
				RW_TAC std_ss [EMPTY_DIFF, GSPEC_F] THEN                	
			ASM_REWRITE_TAC [] THEN
			POP_ASSUM K_TAC THEN
			POP_ASSUM K_TAC THEN
			MATCH_MP_TAC RAND_THM THEN
			REWRITE_TAC [EXTENSION] THEN
			RW_TAC std_ss [DIFF_DEF, GSPECIFICATION] THEN
			Cases_on `std_unif_cont x' = 1` THEN1
				PROVE_TAC [] THEN
			Cases_on `std_unif_cont x' = 0` THEN1
                        	PROVE_TAC [] THEN
			DISJ1_TAC THEN
			CCONTR_TAC THEN
			FULL_SIMP_TAC std_ss [] THEN
			KNOW_TAC `g (f (std_unif_cont x')) <= g x` THEN1
				PROVE_TAC [REAL_LE_LT] THEN
			KNOW_TAC `g (f (std_unif_cont x')) = (std_unif_cont x')` THEN1
				PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
			FULL_SIMP_TAC std_ss [] THEN
			UNDISCH_TAC (--`std_unif_cont (x':num -> bool) 
				<= (g:real -> real) (x:real)`--) THEN
			RW_TAC std_ss [REAL_NOT_LE] THEN
			MP_TAC (Q.SPEC `x'` LB_STD_UNIF_CONT) THEN
			RW_TAC std_ss [REAL_LE_LT],
		
			KNOW_TAC `g (f 0) = 0` THEN1
				PROVE_TAC [] THEN	
			REWRITE_TAC [GSYM REAL_LE_LT] THEN
			KNOW_TAC `prob bern {s | std_unif_cont s <= g x} =
				prob bern ({s | std_unif_cont s <= g x} DIFF 
				{s | std_unif_cont s = 1} DIFF
				{s | std_unif_cont s = 0})` THEN1 (

				KNOW_TAC `{s | std_unif_cont s <= g x} =
                       	 		{s | (\x. x) std_unif_cont s <= g x}` THEN1
                        		RW_TAC std_ss [] THEN
				ONCE_ASM_REWRITE_TAC [] THEN
				MP_TAC (Q.SPECL [`(\x. x)`, `(g:real -> real) x`]
                                SET_DIFF_STD_UNIF_CONT_0_1) THEN
				KILL_ALL_TAC THEN
                		RW_TAC std_ss [] THEN
				FULL_SIMP_TAC std_ss [STD_UNIF_CONT_EVENTS_BERN]) THEN
			ASM_REWRITE_TAC [] THEN
			POP_ASSUM K_TAC THEN
			MATCH_MP_TAC RAND_THM THEN
			REWRITE_TAC [EXTENSION] THEN
			RW_TAC std_ss [GSPECIFICATION, DIFF_DEF] THEN
			REWRITE_TAC [REAL_LE_LT] THEN
			RW_TAC std_ss [GSYM REAL_NOT_LE, LB_STD_UNIF_CONT] THEN
			RW_TAC std_ss [GSYM REAL_LE_LT, REAL_NOT_LE] THEN
			EQ_TAC THENL [
				REPEAT STRIP_TAC THEN
				KNOW_TAC `g (f (std_unif_cont x')) <= g (f 0)` THEN1
					PROVE_TAC [REAL_LE_LT] THEN
				KNOW_TAC `g (f (std_unif_cont x')) = (std_unif_cont x')` THEN1
                       			PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
				FULL_SIMP_TAC std_ss [] THEN
       		        	UNDISCH_TAC (--`std_unif_cont (x':num -> bool)
                                	<= (g:real -> real) ((f:real -> real) (0:real))`--) THEN
				RW_TAC std_ss [REAL_NOT_LE] THEN
				MP_TAC (Q.SPEC `x'` LB_STD_UNIF_CONT) THEN
	                	RW_TAC std_ss [REAL_LE_LT],


				RW_TAC std_ss []]], 
				
			
				FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
				Cases_on `g x < 1` THENL [
					KNOW_TAC `prob bern {s | std_unif_cont s <= g x} =
       				         	prob bern ({s | std_unif_cont s <= g x}
                				DIFF {s | std_unif_cont s = 1} 
						DIFF {s | std_unif_cont s = 0})` THEN1 (
                				KNOW_TAC `{s | std_unif_cont s <= g x} =
                 			       {s | (\x. x) std_unif_cont s <= g x}` THEN1
                	        			RW_TAC std_ss [] THEN
                				ASM_REWRITE_TAC [] THEN
                				MP_TAC (Q.SPECL [`(\x. x)`, `(g:real -> real) x`]
                                		SET_DIFF_STD_UNIF_CONT_0_1) THEN
                				KILL_ALL_TAC THEN
                				RW_TAC std_ss [] THEN
                				FULL_SIMP_TAC std_ss [STD_UNIF_CONT_EVENTS_BERN]) THEN
					ASM_REWRITE_TAC [] THEN
					POP_ASSUM K_TAC THEN
					MATCH_MP_TAC RAND_THM THEN
					REWRITE_TAC [EXTENSION] THEN
					RW_TAC std_ss [DIFF_DEF, GSPECIFICATION] THEN
					KNOW_TAC `(f (g x) = x)` THEN1
						PROVE_TAC [] THEN
					EQ_TAC THENL [
						RW_TAC std_ss [] THEN
						KNOW_TAC `g (f (std_unif_cont x')) <= g x` THEN1
							PROVE_TAC [REAL_LE_LT] THEN
						KNOW_TAC `g (f (std_unif_cont x')) = 
									(std_unif_cont x')` THEN1
                                			PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
						FULL_SIMP_TAC std_ss [],

						RW_TAC std_ss [] THEN
						CCONTR_TAC THEN
						FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
						KNOW_TAC `g x <= g (f (std_unif_cont x'))` THEN1
							PROVE_TAC [REAL_LE_LT] THEN
						KNOW_TAC `g (f (std_unif_cont x')) =
                                                                        (std_unif_cont x')` THEN1
                                                	PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
						FULL_SIMP_TAC std_ss [] THEN
						KNOW_TAC `g x = std_unif_cont x'` THEN1
							PROVE_TAC [REAL_LE_ANTISYM] THEN
						KNOW_TAC `f (g x) = f (std_unif_cont x')` THEN1
							PROVE_TAC [] THEN
						PROVE_TAC [REAL_EQ_IMP_LE, GSYM REAL_NOT_LE]],

						POP_ASSUM MP_TAC THEN
						REWRITE_TAC [REAL_NOT_LT, REAL_LE_LT] THEN
						RW_TAC std_ss [GSYM REAL_NOT_LE, UB_STD_UNIF_CONT] THEN
						KNOW_TAC `f 1 <= x` THEN1
							PROVE_TAC [] THEN
						RW_TAC std_ss [REAL_NOT_LE, GSYM REAL_LE_LT] THEN
						KNOW_TAC `prob bern {s | std_unif_cont s <= g x} =
       		                                 	 prob bern ({s | std_unif_cont s <= g x}
	                                                DIFF {s | std_unif_cont s = 1}
               		                                 DIFF {s | std_unif_cont s = 0})` THEN1 (
       		                                	KNOW_TAC `{s | std_unif_cont s <= g x} =
                       		                        {s | (\x. x) std_unif_cont s <= g x}` THEN1
                               		                 	RW_TAC std_ss [] THEN
							POP_ASSUM MP_TAC THEN
							KILL_ALL_TAC THEN
							STRIP_TAC THEN
							ONCE_ASM_REWRITE_TAC [] THEN	
                                        		MP_TAC (Q.SPECL [`(\x. x)`, 
								`(g:real -> real) x`]
                                                		SET_DIFF_STD_UNIF_CONT_0_1) THEN
                                        		KILL_ALL_TAC THEN
                                        		RW_TAC std_ss [] THEN
                                        		FULL_SIMP_TAC std_ss 
								[STD_UNIF_CONT_EVENTS_BERN]) THEN
						ONCE_ASM_REWRITE_TAC [] THEN
						POP_ASSUM K_TAC THEN
						MATCH_MP_TAC RAND_THM THEN
						REWRITE_TAC [EXTENSION] THEN
						KNOW_TAC `g x = 1` THEN1
							PROVE_TAC [] THEN
						UNDISCH_TAC (--`1 = (g:real -> real) (x:real)`--) THEN
						DISCH_TAC THEN
						POP_ASSUM K_TAC THEN
						RW_TAC bool_ss [GSPECIFICATION, DIFF_DEF] THEN
						EQ_TAC THENL [
							RW_TAC std_ss [] THEN
							KNOW_TAC `g (f (std_unif_cont x')) <= g x` THEN1
                                                		PROVE_TAC [REAL_LE_LT] THEN
                                        		KNOW_TAC `g (f (std_unif_cont x')) =
                                                                        (std_unif_cont x')` THEN1
                                                		PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
                                        		PROVE_TAC [],
					
							RW_TAC std_ss [] THEN
							CCONTR_TAC THEN
							FULL_SIMP_TAC std_ss [REAL_NOT_LE] THEN
							KNOW_TAC `g x <= g (f (std_unif_cont x'))` THEN1
								PROVE_TAC [REAL_LE_LT] THEN
							KNOW_TAC `g (f (std_unif_cont x')) =
                                                                        (std_unif_cont x')` THEN1
                                                        	PROVE_TAC [STD_UNIF_CONT_NEQ_0_1] THEN
							FULL_SIMP_TAC std_ss [] THEN
							KNOW_TAC `std_unif_cont x' = g x` THEN1
								PROVE_TAC [GSYM REAL_LE_ANTISYM] THEN
							KNOW_TAC `f (std_unif_cont x') = f (g x)` THEN1
								PROVE_TAC [] THEN
							KNOW_TAC `x < f (g x)` THEN1 (
								MATCH_MP_TAC REAL_LTE_TRANS THEN
							 	EXISTS_TAC (--`(f : real -> real) 
								(std_unif_cont 
									(x':num -> bool))`--) THEN
								PROVE_TAC []) THEN	
							PROVE_TAC [real_lte]]]]); 
	

val ITM = store_thm
   ("ITM",
   (--`!f g x. IS_CONT_CDF_FN g /\
                (INV_CDF_FN f g) ==>
                (prob bern {s | f (std_unif_cont s) <= x} = g x)`--),	
REPEAT STRIP_TAC THEN
POP_ASSUM MP_TAC THEN
KNOW_TAC `(!x. 0 <= g x /\ g x <= 1)` THEN1
        PROVE_TAC [LIM_POS1_NEG0_IMP_GE0_LE1] THEN
UNDISCH_TAC (--`IS_CONT_CDF_FN g`--) THEN
DISCH_TAC THEN

KNOW_TAC `(?y. 0 < g y /\ g y < 1)` THEN1
        PROVE_TAC [CONT_CDF_EXISTS_GT0_LT1] THEN
STRIP_TAC THEN
FULL_SIMP_TAC std_ss [INV_CDF_FN_def, IS_CONT_CDF_FN_def] THEN
	
KNOW_TAC `g x = prob bern {s | std_unif_cont s <= g x}` THEN1 (
			ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
			MATCH_MP_TAC CDF_UNIF_CONT_GE0_LE1 THEN
			PROVE_TAC [REAL_LT_IMP_LE]) THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	MATCH_MP_TAC ITM_HELPER THEN			
	RW_TAC std_ss [IS_CONT_CDF_FN_def] THEN
	REWRITE_TAC [INV_CDF_FN_def] THEN 
	PROVE_TAC []);

val _ = export_theory();
	
