open HolKernel Parse boolLib bossLib arithmeticTheory pred_setTheory
     listTheory sequenceTheory state_transformerTheory
     probabilityTheory formalizeUseful extra_numTheory combinTheory
     pairTheory realTheory realLib extra_boolTheory jrhUtils
     extra_pred_setTheory prob_algebraTheory probTheory realSimps
     extra_realTheory extra_pred_setTools measureTheory numTheory
     simpLib prob_extraTheory probTools prob_extraTools pred_setLib
     seqTheory std_unifTheory subtypeTheory prob_uniformTheory 
     prob_bernoulliTheory prob_bernoulli_pTheory binomialTheory
     prob_uniformTheory prob_bernoulliTheory disc_expecTheory 
     disc_varianceTheory transcTheory;
     
val _ = new_theory "coupon_collector";

val geo_rv_lst_def = Define
	`(geo_rv_lst 0 (k: num) = [prob_geometric_p 1]) /\
         (geo_rv_lst (SUC n) k = 
		(prob_geometric_p (&(k-(SUC n))/(&k))) :: (geo_rv_lst n k))`;

val dist_lst_def = Define
	`(dist_lst [] = T) /\
	 (dist_lst (h::t) = ~(MEM h t) /\ (dist_lst t))`;

val geo_rv_unif_lst_def = Define
	`(geo_rv_unif_lst [] (k: num) = [prob_geometric_p 1]) /\
         (geo_rv_unif_lst (h::t) k = 
		(prob_geometric_p (prob bern {s | ~ MEM (FST (prob_uniform k s)) (h::t)}) 
							:: (geo_rv_unif_lst t k)))`;
val my_coupon_lst_def = Define
	`(my_coupon_lst 0 = []) /\
	 (my_coupon_lst (SUC n) = (n:num) :: (my_coupon_lst n))`;

val LENGTH_GEO_RV_LIST = store_thm
 ("LENGTH_GEO_RV_LIST",
 (--`!k n. LENGTH (geo_rv_lst n k) = (SUC n)`--),
	GEN_TAC THEN
	Induct THEN
		RW_TAC std_ss [geo_rv_lst_def, LENGTH]);


val EL_GEO_RV_LIST = store_thm
 ("EL_GEO_RV_LIST",
 (--`!j n k. (n < k) /\ (j <= n) ==>
	(EL j (geo_rv_lst n k) = prob_geometric_p (&(k - (n-j))/(&k)))`--),
	REPEAT STRIP_TAC THEN
	POP_ASSUM MP_TAC THEN
	Q.SPEC_TAC (`j`, `j`) THEN
	Induct_on `n` THEN1
		RW_TAC arith_ss [EL, geo_rv_lst_def, HD, REAL_LT, REAL_DIV_REFL, REAL_POS_NZ] THEN
	
		RW_TAC arith_ss [] THEN
		FULL_SIMP_TAC arith_ss [] THEN
		Cases_on `j` THEN1
			RW_TAC arith_ss [EL, geo_rv_lst_def, HD] THEN

			RW_TAC arith_ss [EL, geo_rv_lst_def, TL] THEN
			KNOW_TAC `(k + n' - n) = (k + SUC n' - SUC n)` THEN1
				DECIDE_TAC THEN
			ASM_REWRITE_TAC []);

val EXPEC_GEO_RV_LIST = store_thm
 ("EXPEC_GEO_RV_LIST",
 (--`!j n. (j <= n) ==> 
			(expec (EL j (geo_rv_lst n (SUC n))) = &(SUC n)/(&(SUC j)))`--),
	REPEAT STRIP_TAC THEN
	SUFF_TAC `EL j (geo_rv_lst n (SUC n)) = prob_geometric_p (&(SUC j)/(&(SUC n)))` THEN1 (
		RW_TAC std_ss [] THEN
		KNOW_TAC `expec (prob_geometric_p (& (SUC j) / & (SUC n))) =
		expec (\s. prob_geometric_p (& (SUC j) / & (SUC n)) s)` THEN1 (
			MATCH_MP_TAC RAND_THM THEN
			PROVE_TAC [ETA_THM]) THEN
		ASM_REWRITE_TAC [] THEN
		KNOW_TAC `& (SUC n) / & (SUC j) = 1 / (& (SUC j) / & (SUC n))` THEN1 (
			RW_TAC real_ss [real_div, REAL_INVINV, REAL_LE, REAL_INV_MUL,
				REAL_INV_POS, REAL_POS_NZ] THEN
			PROVE_TAC [REAL_MUL_SYM]) THEN
		ASM_REWRITE_TAC [] THEN
		MATCH_MP_TAC EXPEC_GEOMETRIC THEN
		RW_TAC real_ss [REAL_LE, REAL_LT, REAL_LT_RDIV_0, REAL_LE_LDIV_EQ]) THEN
	
		MP_TAC (Q.SPECL [`j`, `n`, `SUC n`] EL_GEO_RV_LIST) THEN
		RW_TAC arith_ss [] THEN
		KNOW_TAC `(j + SUC n - n) = (SUC j)` THEN1
			DECIDE_TAC THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss []);

val INDEP_FN_GEO_RV_LIST = store_thm
 ("INDEP_FN_GEO_RV_LIST",
 (--`!h (n:num) k. (n < k) /\ 
	(IS_EL h (geo_rv_lst n k)) ==> (h IN indep_fn)`--),
	REPEAT STRIP_TAC THEN
	Induct_on `n` THEN1 (
		RW_TAC std_ss [geo_rv_lst_def, MEM] THEN
		MATCH_MP_TAC INDEP_FN_PROB_GEOMETRIC_P THEN
		RW_TAC real_ss [REAL_LE_REFL]) THEN

		RW_TAC std_ss [geo_rv_lst_def, MEM] THENL [
			MATCH_MP_TAC INDEP_FN_PROB_GEOMETRIC_P THEN
			KNOW_TAC `0 < (&k)` THEN1
				RW_TAC arith_ss [REAL_LT] THEN
			FULL_SIMP_TAC real_ss [REAL_LT_RDIV_0, REAL_LE_LDIV_EQ],

		FULL_SIMP_TAC arith_ss []]);

val SUMMABLE_GEO_RV_LIST = store_thm
 ("SUMMABLE_GEO_RV_LIST",
 (--`!(a: (num->bool)->(num#(num->bool))) (n:num) k. 
	(n < k) /\ (IS_EL a (geo_rv_lst n k)) ==>
            (summable (\x. & x * prob bern {s | FST (a s) = x}))`--),
	REPEAT STRIP_TAC THEN
	Induct_on `n` THENL [
		RW_TAC std_ss [geo_rv_lst_def, MEM] THEN
		MATCH_MP_TAC EXPEC_GEOMETRIC_SUMMABLE THEN
		RW_TAC real_ss [REAL_LE_REFL],

		RW_TAC arith_ss [geo_rv_lst_def, MEM] THENL [	
			MATCH_MP_TAC EXPEC_GEOMETRIC_SUMMABLE THEN
			KNOW_TAC `0 < k/\ n < k` THEN1
				DECIDE_TAC THEN
			FULL_SIMP_TAC arith_ss [REAL_LT_RDIV_0, REAL_LT,
			REAL_LE_LDIV_EQ, REAL_LE, REAL_MUL, suminf, sums],
	
			FULL_SIMP_TAC arith_ss []]]);

val EXPEC_SUM_RV_GEO_RV_LIST = store_thm
 ("EXPEC_SUM_RV_GEO_RV_LIST",
 (--`!n. (expec (sum_rv_lst (geo_rv_lst n (SUC n))) =
	sum (0,LENGTH ((geo_rv_lst n (SUC n)))) 
		(\x. expec (EL (LENGTH ((geo_rv_lst n (SUC n))) - (x + 1)) (geo_rv_lst n (SUC n)))))`--),
	REPEAT STRIP_TAC THEN
	MATCH_MP_TAC EXPEC_SUM_N_RV THEN
	CONJ_TAC THENL [
		REPEAT STRIP_TAC THEN
		MATCH_MP_TAC INDEP_FN_GEO_RV_LIST THEN
		EXISTS_TAC (--`n:num`--) THEN
		EXISTS_TAC (--`SUC n`--) THEN
		RW_TAC arith_ss [],

		REPEAT STRIP_TAC THEN
		MATCH_MP_TAC SUMMABLE_GEO_RV_LIST THEN
		EXISTS_TAC (--`n:num`--) THEN
		EXISTS_TAC (--`SUC n`--) THEN
		RW_TAC arith_ss []]);

val SUM_INV_SUCN_UP_DOWN_EQ = store_thm
 ("SUM_INV_SUCN_UP_DOWN_EQ",
 (--`!n. sum (0, SUC n) (\i. 1/(&((SUC n) - i))) =
                        sum (0, SUC n) (\i. 1/(&(SUC i)))`--),
	GEN_TAC THEN
	KNOW_TAC `sum (0, SUC n) (\i. 1/(&((SUC n) - i))) = 
		sum (0, SUC n) (\i. 1/(&(SUC (n - i))))` THEN1 (
		MATCH_MP_TAC SUM_EQ THEN
		RW_TAC real_ss [real_div, REAL_INJ, REAL_INV_INJ]) THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	KNOW_TAC `(\i. 1 / & (SUC (n - i))) = (\i. (\i. 1 / & (SUC i)) ((\i. n - i) i))` THEN1
		RW_TAC std_ss [] THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	MATCH_MP_TAC SUM_PERMUTE_0 THEN
	RW_TAC std_ss [EXISTS_UNIQUE_THM] THENL [
		EXISTS_TAC (--`n - y:num`--) THEN
		RW_TAC arith_ss [],

		RW_TAC arith_ss []]);


val EXPEC_SUM_GEO_RV_LIST = store_thm
 ("EXPEC_SUM_GEO_RV_LIST",
 (--`!n. (expec (sum_rv_lst (geo_rv_lst n (SUC n))) = 
		(&(SUC n)) * (sum (0,(SUC n)) (\i. 1/(&(SUC i)))))`--),
	RW_TAC std_ss [EXPEC_SUM_RV_GEO_RV_LIST, LENGTH_GEO_RV_LIST] THEN
	KNOW_TAC `sum (0,SUC n)
      		(\x. expec (EL (SUC n - (x + 1)) (geo_rv_lst n (SUC n)))) =
		 sum (0,SUC n) (\x. & (SUC n) / & (SUC (SUC n - (x + 1))))` THEN1 (
		MATCH_MP_TAC SUM_EQ THEN
		RW_TAC std_ss [] THEN
		MATCH_MP_TAC EXPEC_GEO_RV_LIST THEN
		RW_TAC arith_ss []) THEN
	ASM_REWRITE_TAC [] THEN
	KNOW_TAC `sum (0,SUC n) (\x. & (SUC n) / & (SUC (SUC n - (x + 1)))) = 
		sum (0,SUC n) (\x. & (SUC n) / & (SUC n - x))` THEN1 (
		MATCH_MP_TAC SUM_EQ THEN
		RW_TAC arith_ss [] THEN	
		KNOW_TAC `(SUC (SUC n - (r + 1))) = (SUC n - r)` THEN1
			DECIDE_TAC THEN
		ASM_REWRITE_TAC []) THEN
	ASM_REWRITE_TAC [real_div] THEN
	KNOW_TAC `(\x. & (SUC n) * inv (& (SUC n - x))) = 
	(\x. (\x. & (SUC n)) x * (\x. inv (& (SUC n - x))) x)` THEN1
		RW_TAC std_ss [] THEN
	RW_TAC real_ss [SUM_CMUL, REAL_EQ_MUL_LCANCEL, REAL_INV_1OVER,
					SUM_INV_SUCN_UP_DOWN_EQ]);


val PROB_BERN_OLD_COUPON = store_thm
 ("PROB_BERN_OLD_COUPON",
 (--`!ccl n. (dist_lst ccl) /\ 
		(!a. MEM a ccl ==> (a < (SUC n))) ==>
	(prob bern {s | MEM (FST (prob_uniform (SUC n) s)) ccl} = &(LENGTH ccl)/(&(SUC n)))`--),
	REPEAT STRIP_TAC THEN
	Induct_on `ccl` THEN1
		RW_TAC real_ss [LENGTH, MEM, GSPEC_F, PROB_BERN_BASIC] THEN

		RW_TAC real_ss [LENGTH, MEM, GSPEC_F, PROB_BERN_BASIC] THEN
		KNOW_TAC `dist_lst ccl` THEN1 (
			POP_ASSUM K_TAC THEN
			POP_ASSUM MP_TAC THEN
			RW_TAC std_ss [dist_lst_def]) THEN
		FULL_SIMP_TAC bool_ss [] THEN
		SUFF_TAC `prob bern {s |
       			(FST (prob_uniform (SUC n) s) = h) \/
       			IS_EL (FST (prob_uniform (SUC n) s)) ccl} = 
			prob bern {s | (FST (prob_uniform (SUC n) s) = h)} + 
			prob bern {s | IS_EL (FST (prob_uniform (SUC n) s)) ccl}` THEN1 (
			KNOW_TAC `h < SUC n` THEN1
				FULL_SIMP_TAC std_ss [] THEN
			RW_TAC arith_ss [PROB_BERN_UNIFORM, REAL_DIV_ADD,
			REAL_ADD, GSYM ADD1]) THEN
		
			MATCH_MP_TAC PROB_ADDITIVE THEN
			RW_TAC std_ss [PROB_SPACE_BERN, DISJOINT_DEF, 
					INTER_DEF, SPECIFICATION, IN_FUNSET] THENL [
			
			ONCE_REWRITE_TAC [GSYM SPECIFICATION] THEN
			KNOW_TAC  `{s | FST (prob_uniform (SUC n) s) = h} =
                        	((\y. y = h) o FST o prob_uniform (SUC n))` THEN1
                        	PSET_TAC [o_DEF] THEN
                	ASM_REWRITE_TAC [] THEN
			MATCH_MP_TAC INDEP_FN_FST_EVENTS THEN
                	RW_TAC std_ss [INDEP_FN_PROB_UNIFORM],

				ONCE_REWRITE_TAC [GSYM SPECIFICATION] THEN
				KNOW_TAC  `{s | IS_EL (FST (prob_uniform (SUC n) s)) ccl} =
                        		((\y. IS_EL y ccl) o FST o prob_uniform (SUC n))` THEN1
                        		PSET_TAC [o_DEF] THEN
                		ASM_REWRITE_TAC [] THEN
                		MATCH_MP_TAC INDEP_FN_FST_EVENTS THEN
                		RW_TAC std_ss [INDEP_FN_PROB_UNIFORM],

				REWRITE_TAC [EXTENSION] THEN
				PSET_TAC [GSPECIFICATION] THEN
				Cases_on `h = FST (prob_uniform (SUC n) x')` THEN1
					FULL_SIMP_TAC std_ss [dist_lst_def] THEN					
		
					PROVE_TAC [],
			
				REWRITE_TAC [EXTENSION] THEN
				PSET_TAC [GSPECIFICATION, IN_UNION]]);

val PROB_BERN_COMPL_OLD_COUPON = store_thm
 ("PROB_BERN_COMPL_OLD_COUPON",
 (--`!cc1 n.  (prob bern (COMPL {s | MEM (FST (prob_uniform (SUC n) s)) ccl}) = 
		1 - prob bern {s | MEM (FST (prob_uniform (SUC n) s)) ccl})`--),
	RW_TAC std_ss [GSYM PROB_BERN_UNIV] THEN
	REWRITE_TAC [prob_def] THEN
	SUFF_TAC `measure bern UNIV = measure bern {s | MEM (FST (prob_uniform (SUC n) s)) ccl} 
		+ measure bern (COMPL {s | MEM (FST (prob_uniform (SUC n) s)) ccl})` THEN1
		REAL_ARITH_TAC THEN
	MATCH_MP_TAC ADDITIVE THEN
	RW_TAC std_ss [] THENL [
		MATCH_MP_TAC COUNTABLY_ADDITIVE_ADDITIVE THEN
		CONJ_TAC THENL [
			RW_TAC std_ss [GSYM events_def] THEN
			MATCH_MP_TAC EVENTS_ALGEBRA THEN
			RW_TAC std_ss [PROB_SPACE_BERN],

			CONJ_TAC THENL [
				MATCH_MP_TAC PROB_SPACE_POSITIVE THEN
				RW_TAC std_ss [PROB_SPACE_BERN],
			
				MATCH_MP_TAC PROB_SPACE_COUNTABLY_ADDITIVE THEN
				RW_TAC std_ss [PROB_SPACE_BERN]]],

	
		ONCE_REWRITE_TAC [GSYM events_def] THEN
		KNOW_TAC  `{s | IS_EL (FST (prob_uniform (SUC n) s)) ccl} =
                   	((\y. IS_EL y ccl) o FST o prob_uniform (SUC n))` THEN1
			PSET_TAC [o_DEF] THEN
        	ASM_REWRITE_TAC [] THEN
        	MATCH_MP_TAC INDEP_FN_FST_EVENTS THEN
        	RW_TAC std_ss [INDEP_FN_PROB_UNIFORM],

		KNOW_TAC `COMPL {s | IS_EL (FST (prob_uniform (SUC n) s)) ccl} =
		{s | ~IS_EL (FST (prob_uniform (SUC n) s)) ccl}` THEN1 (
			REWRITE_TAC [EXTENSION] THEN
			PSET_TAC [GSPECIFICATION, IN_COMPL]) THEN
		ASM_REWRITE_TAC [] THEN
		ONCE_REWRITE_TAC [GSYM events_def] THEN
		KNOW_TAC  `{s | ~IS_EL (FST (prob_uniform (SUC n) s)) ccl} =
                   	((\y. ~IS_EL y ccl) o FST o prob_uniform (SUC n))` THEN1
			PSET_TAC [o_DEF] THEN
        	ASM_REWRITE_TAC [] THEN
        	MATCH_MP_TAC INDEP_FN_FST_EVENTS THEN
        	RW_TAC std_ss [INDEP_FN_PROB_UNIFORM],


		RW_TAC std_ss [DISJOINT_DEF] THEN
		REWRITE_TAC [EXTENSION] THEN
		PSET_TAC [GSPECIFICATION, IN_COMPL, IN_INTER],

		REWRITE_TAC [EXTENSION] THEN
		PSET_TAC [GSPECIFICATION, IN_COMPL, IN_UNION, IN_UNION]]);

val PROB_BERN_NEW_COUPON = store_thm
 ("PROB_BERN_NEW_COUPON",
 (--`!ccl n. (dist_lst ccl) /\ 
		(!a. MEM a ccl ==> (a < (SUC n))) ==>
	(prob bern {s | ~ MEM (FST (prob_uniform (SUC n) s)) ccl} = 
				 1 - (&(LENGTH ccl))/(&(SUC n)))`--),
	RW_TAC std_ss [] THEN
	SUFF_TAC `({s | ~MEM (FST (prob_uniform (SUC n) s)) ccl} = 
		COMPL {s | MEM (FST (prob_uniform (SUC n) s)) ccl})` THEN1
		RW_TAC std_ss [PROB_BERN_COMPL_OLD_COUPON, PROB_BERN_OLD_COUPON] THEN

		REWRITE_TAC [EXTENSION] THEN
		PSET_TAC [GSPECIFICATION, IN_COMPL]);

val MEM_MY_COUPON_LST_LT_N = store_thm
 ("MEM_MY_COUPON_LST_LT_N",
 (--`(!n a. MEM a (my_coupon_lst n) ==> (a < n))`--),
	REPEAT GEN_TAC THEN
	Induct_on `n` THEN1
        	RW_TAC std_ss [my_coupon_lst_def, dist_lst_def, MEM] THEN
        	RW_TAC arith_ss [my_coupon_lst_def, dist_lst_def, MEM] THEN1
                	DECIDE_TAC THEN
                	FULL_SIMP_TAC arith_ss []);

val MEM_MY_COUPON_LST_LT_SUCN = store_thm
 ("MEM_MY_COUPON_LST_LT_SUCN",
 (--`(!n a. MEM a (my_coupon_lst n) ==> (a < SUC n))`--),
	RW_TAC std_ss [] THEN
	MATCH_MP_TAC LESS_TRANS THEN
	EXISTS_TAC (--`n:num`--) THEN
	RW_TAC arith_ss [MEM_MY_COUPON_LST_LT_N]);

val DIST_LST_MY_COUPON_LST = store_thm
 ("DIST_LST_MY_COUPON_LST",
 (--`!n. (dist_lst (my_coupon_lst n))`--),
	Induct THEN1
        	RW_TAC std_ss [my_coupon_lst_def, dist_lst_def] THEN

		RW_TAC std_ss [my_coupon_lst_def, dist_lst_def] THEN
		CCONTR_TAC THEN
		FULL_SIMP_TAC std_ss [] THEN
		MP_TAC (Q.SPECL [`n`, `n`] MEM_MY_COUPON_LST_LT_N) THEN
		FULL_SIMP_TAC arith_ss []);

val EXPEC_CCP_HELPER = store_thm
 ("EXPEC_CCP_HELPER",
 (--`!n. (geo_rv_unif_lst (my_coupon_lst n) (SUC n)) = (geo_rv_lst n (SUC n))`--),
	RW_TAC std_ss [] THEN
        MP_TAC (Q.SPEC `n` MEM_MY_COUPON_LST_LT_SUCN) THEN
        MP_TAC (Q.SPEC `n` DIST_LST_MY_COUPON_LST) THEN
        MP_TAC NUM_NUM_POWN_ZERO THEN
        REPEAT STRIP_TAC THEN
	RW_TAC std_ss [EXPEC_SUM_GEO_RV_LIST] THEN

                KNOW_TAC `n < SUC n` THEN1
                        DECIDE_TAC THEN
                KNOW_TAC `0 < SUC n` THEN1
                        DECIDE_TAC THEN
                NTAC 3 (POP_ASSUM MP_TAC) THEN
                Q.SPEC_TAC (`SUC n`, `k`) THEN
                RW_TAC std_ss [] THEN
                Cases_on `k` THEN1
                        FULL_SIMP_TAC arith_ss [] THEN

                        Induct_on `n` THEN1 (
                                RW_TAC std_ss [my_coupon_lst_def, geo_rv_lst_def,
                                geo_rv_unif_lst_def]) THEN

                                RW_TAC std_ss [my_coupon_lst_def, geo_rv_unif_lst_def,
                                geo_rv_lst_def] THENL [
                                        KNOW_TAC `(prob bern {s |
                                                ~IS_EL (FST (prob_uniform (SUC n') s))
                                                (n::my_coupon_lst n)}) =
                                                1 - (&(LENGTH (n::my_coupon_lst n)))/(&((SUC n')))` THEN1 (
                                                MATCH_MP_TAC PROB_BERN_NEW_COUPON THEN
                                                RW_TAC std_ss [dist_lst_def, MEM]) THEN
                                        RW_TAC std_ss [] THEN
                                        MATCH_MP_TAC RAND_THM THEN
                                        KNOW_TAC `& (SUC n' - SUC n) =
                                                & (SUC n') - &(SUC n)` THEN1
                                                RW_TAC arith_ss [REAL_SUB] THEN
                                        ASM_REWRITE_TAC [] THEN
                                        RW_TAC arith_ss [GSYM REAL_DIV_ADD, real_sub,
                                        REAL_DIV_REFL, REAL_POS_NZ, REAL_LT, REAL_EQ_LADD] THEN
                                        RW_TAC std_ss [REAL_INJ, real_div, REAL_NEG_LMUL, REAL_EQ_RMUL, REAL_EQ_NEG] THEN
                                        DISJ2_TAC THEN
                                        KILL_TAC THEN
                                        Induct_on `n` THEN1
                                                RW_TAC arith_ss [LENGTH, my_coupon_lst_def] THEN

                                                RW_TAC arith_ss [LENGTH, my_coupon_lst_def],

                                        FULL_SIMP_TAC std_ss [dist_lst_def, MEM]]);


val EXPEC_CCP = store_thm
 ("EXPEC_CCP",
 (--`!n. (expec (sum_rv_lst (geo_rv_unif_lst (my_coupon_lst n) (SUC n))) =
                        (&(SUC n)) * (sum (0,(SUC n)) (\i. 1/(&(SUC i)))))`--),

	RW_TAC std_ss [] THEN
	MP_TAC (Q.SPEC `n` MEM_MY_COUPON_LST_LT_SUCN) THEN
       	MP_TAC (Q.SPEC `n` DIST_LST_MY_COUPON_LST) THEN
        MP_TAC NUM_NUM_POWN_ZERO THEN
        REPEAT STRIP_TAC THEN
        SUFF_TAC `(geo_rv_unif_lst (my_coupon_lst n) (SUC n)) =
                 (geo_rv_lst n (SUC n))` THEN1
                RW_TAC std_ss [EXPEC_SUM_GEO_RV_LIST] THEN
	RW_TAC std_ss [EXPEC_CCP_HELPER]);

val CC_MARKOV_BOUND = store_thm
 ("CC_MARKOV_BOUND",
 (--`!n a. (0 < a) ==>
	(prob bern {s | & (FST ((sum_rv_lst (geo_rv_unif_lst (my_coupon_lst n) (SUC n)) s))) >= a} 
			<= (&(SUC n)) * (sum (0,(SUC n)) (\i. 1/(&(SUC i)))) / a)`--),
	RW_TAC std_ss [GSYM EXPEC_CCP] THEN
	MATCH_MP_TAC MARKOV_INEQUALITY THEN
	RW_TAC std_ss [] THENL [
		MATCH_MP_TAC INDEP_FN_SUM_RV_LIST THEN
		RW_TAC std_ss [] THEN
		MATCH_MP_TAC INDEP_FN_GEO_RV_LIST THEN
		EXISTS_TAC (--`n:num`--) THEN
		EXISTS_TAC (--`SUC n:num`--) THEN
		FULL_SIMP_TAC arith_ss [EXPEC_CCP_HELPER],
	
		MATCH_MP_TAC SUM_N_RV_SUMMABLE THEN
		RW_TAC std_ss [EXPEC_CCP_HELPER] THENL [
			MATCH_MP_TAC INDEP_FN_GEO_RV_LIST THEN
			EXISTS_TAC (--`n:num`--) THEN
			EXISTS_TAC (--`SUC n:num`--) THEN
			RW_TAC arith_ss [],

			MATCH_MP_TAC SUMMABLE_GEO_RV_LIST THEN
			EXISTS_TAC (--`n:num`--) THEN
			EXISTS_TAC (--`SUC n:num`--) THEN
			RW_TAC arith_ss []]]);


(********************************************************************);

val VARIANCE_GEOMETRIC_LT_INV_PROB_POW2 = store_thm
 ("VARIANCE_GEOMETRIC_LT_INV_PROB_POW2",
 (--`!p. 0 < p /\ p <= 1 ==>
	(variance (\s. prob_geometric_p p s) <= 1/p pow 2)`--),
	RW_TAC std_ss [VARIANCE_GEOMETRIC, real_div] THEN
	MATCH_MP_TAC REAL_LE_RMUL_IMP THEN
	RW_TAC std_ss [REAL_LE_SUB_RADD, REAL_LE_ADDR, REAL_LT_IMP_LE, REAL_INV_POS,
	REAL_POW_LT]);




val VARIANCE_LT_GEO_RV_LIST = store_thm
 ("VARIANCE_LT_GEO_RV_LIST",
 (--`!j n. (j <= n) ==> 
 	(variance (EL j (geo_rv_lst n (SUC n))) <= (&(SUC n)/(&(SUC j))) pow 2)`--),
	REPEAT STRIP_TAC THEN
	SUFF_TAC `EL j (geo_rv_lst n (SUC n)) = prob_geometric_p (&(SUC j)/(&(SUC n)))` THEN1 (
		RW_TAC std_ss [] THEN
		KNOW_TAC `variance (prob_geometric_p (& (SUC j) / & (SUC n))) =
		variance (\s. prob_geometric_p (& (SUC j) / & (SUC n)) s)` THEN1 (
			MATCH_MP_TAC RAND_THM THEN
			PROVE_TAC [ETA_THM]) THEN
		ASM_REWRITE_TAC [] THEN
		KNOW_TAC `(& (SUC n) / & (SUC j))  = 
			1 / ((& (SUC j) / & (SUC n)))` THEN1 (
			RW_TAC real_ss [real_div, REAL_INVINV, REAL_LE, REAL_INV_MUL,
				REAL_INV_POS, REAL_POS_NZ] THEN
			PROVE_TAC [REAL_MUL_SYM]) THEN
		ASM_REWRITE_TAC [] THEN
		KNOW_TAC `(1 / (& (SUC j) / & (SUC n))) pow 2 = 
			1 / (& (SUC j) / & (SUC n)) pow 2` THEN1 (
			ONCE_REWRITE_TAC [real_div] THEN
			REWRITE_TAC [REAL_MUL_LID] THEN
			PROVE_TAC [REAL_POW_INV]) THEN
		ASM_REWRITE_TAC [] THEN
		MATCH_MP_TAC VARIANCE_GEOMETRIC_LT_INV_PROB_POW2 THEN
		RW_TAC real_ss [REAL_LE, REAL_LT, REAL_LT_RDIV_0, REAL_LE_LDIV_EQ]) THEN
	
		MP_TAC (Q.SPECL [`j`, `n`, `SUC n`] EL_GEO_RV_LIST) THEN
		RW_TAC arith_ss [] THEN
		KNOW_TAC `(j + SUC n - n) = (SUC j)` THEN1
			DECIDE_TAC THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss []);


val SUMMABLE_SECOND_MOMENT_GEO_RV_LIST = store_thm
 ("SUMMABLE_SECOND_MOMENT_GEO_RV_LIST",
 (--`!(a: (num->bool)->(num#(num->bool))) (n:num) k. 
	(n < k) /\ (IS_EL a (geo_rv_lst n k)) ==>
            (summable (\x. & x pow 2 * prob bern {s | FST (a s) = x}))`--),
	REPEAT STRIP_TAC THEN
	Induct_on `n` THENL [
		RW_TAC std_ss [geo_rv_lst_def, MEM] THEN
		MATCH_MP_TAC SUM_SUMMABLE  THEN
		EXISTS_TAC (--`(2 / 1 pow 2 - 1 / 1)`--) THEN
		MATCH_MP_TAC SECOND_MOMENT_GEOMETRIC_SUMS THEN
		RW_TAC real_ss [],

		RW_TAC arith_ss [geo_rv_lst_def, MEM] THENL [	
			MATCH_MP_TAC SUM_SUMMABLE  THEN
			EXISTS_TAC (--`(2 / (& (k - SUC n) / & k) pow 2 - 
				1 / (& (k - SUC n) / & k))`--) THEN
			MATCH_MP_TAC SECOND_MOMENT_GEOMETRIC_SUMS THEN
			KNOW_TAC `0 < k/\ n < k` THEN1
				DECIDE_TAC THEN
			FULL_SIMP_TAC arith_ss [REAL_LT_RDIV_0, REAL_LT,
			REAL_LE_LDIV_EQ, REAL_LE, REAL_MUL, suminf, sums],
	
			FULL_SIMP_TAC arith_ss []]]);

val VARIANCE_SUM_RV_GEO_RV_LIST = store_thm
 ("VARIANCE_SUM_RV_GEO_RV_LIST",
 (--`(variance (sum_rv_lst (geo_rv_lst n (SUC n))) =
	sum (0,LENGTH ((geo_rv_lst n (SUC n)))) 
		(\x. variance 
		(EL (LENGTH ((geo_rv_lst n (SUC n))) - (x + 1)) (geo_rv_lst n (SUC n)))))`--),
	REPEAT STRIP_TAC THEN
	MATCH_MP_TAC VARIANCE_SUM_N_RV THEN
	CONJ_TAC THENL [
		REPEAT STRIP_TAC THEN
		MATCH_MP_TAC INDEP_FN_GEO_RV_LIST THEN
		EXISTS_TAC (--`n:num`--) THEN
		EXISTS_TAC (--`SUC n`--) THEN
		RW_TAC arith_ss [],

		REPEAT STRIP_TAC THENL [
			MATCH_MP_TAC SUMMABLE_SECOND_MOMENT_GEO_RV_LIST THEN
			EXISTS_TAC (--`n:num`--) THEN
			EXISTS_TAC (--`SUC n`--) THEN
			RW_TAC arith_ss [],
		
		
			MATCH_MP_TAC SUMMABLE_GEO_RV_LIST THEN
			EXISTS_TAC (--`n:num`--) THEN
			EXISTS_TAC (--`SUC n`--) THEN
			RW_TAC arith_ss []]]);


val VARIANCE_SUM_GEO_RV_LIST = store_thm
 ("VARIANCE_SUM_GEO_RV_LIST",
 (--`!n. (variance (sum_rv_lst (geo_rv_lst n (SUC n))) <= 
		(&(SUC n)) pow 2 * (sum (0,(SUC n)) (\i. 1/(&(SUC i)) pow 2)))`--),
	RW_TAC std_ss [VARIANCE_SUM_RV_GEO_RV_LIST, LENGTH_GEO_RV_LIST] THEN
	KNOW_TAC `sum (0,SUC n)
      		(\x. variance (EL (SUC n - (x + 1)) (geo_rv_lst n (SUC n)))) <=
		 sum (0,SUC n) (\x. (& (SUC n) / & (SUC (SUC n - (x + 1)))) pow 2)` THEN1 (
		MATCH_MP_TAC SUM_LE THEN
		RW_TAC std_ss [] THEN
		MATCH_MP_TAC VARIANCE_LT_GEO_RV_LIST THEN
		RW_TAC arith_ss []) THEN
	MATCH_MP_TAC REAL_LE_TRANS THEN
	EXISTS_TAC (--`sum (0,SUC n) (\x. (& (SUC n) / & (SUC (SUC n - (x + 1)))) pow 2)`--) THEN
	ASM_REWRITE_TAC [] THEN
	KNOW_TAC `sum (0,SUC n) (\x. (& (SUC n) / & (SUC (SUC n - (x + 1)))) pow 2) = 
		sum (0,SUC n) (\x. (& (SUC n) / & (SUC n - x)) pow 2)` THEN1 (
		MATCH_MP_TAC SUM_EQ THEN
		RW_TAC arith_ss [] THEN	
		KNOW_TAC `(SUC (SUC n - (r + 1))) = (SUC n - r)` THEN1
			DECIDE_TAC THEN
		ASM_REWRITE_TAC []) THEN
	ASM_REWRITE_TAC [real_div, POW_MUL] THEN
	KNOW_TAC `(\x. & (SUC n) pow 2 * inv (& (SUC n - x)) pow 2) = 
		(\x. & (SUC n) pow 2 * (\x. inv (& (SUC n - x)) pow 2) x)` THEN1
		RW_TAC std_ss [] THEN
	ASM_REWRITE_TAC [SUM_CMUL] THEN
	MATCH_MP_TAC REAL_LE_LMUL_IMP THEN
	RW_TAC real_ss [POW_POS] THEN
	KNOW_TAC `sum (0,SUC n) (\x. inv (& (SUC n - x)) pow 2) = 
		sum (0,SUC n) (\x. inv (& (SUC (n - x))) pow 2)` THEN1 (
		MATCH_MP_TAC SUM_EQ THEN
		RW_TAC arith_ss [real_div, REAL_INJ, REAL_INV_INJ, REAL_POW_INV] THEN
		KNOW_TAC `(SUC n - r) = (SUC (n - r))` THEN1
			RW_TAC arith_ss [] THEN
		ASM_REWRITE_TAC []) THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	KNOW_TAC `(\x. inv (& (SUC (n - x))) pow 2) = 
		(\i. (\i. inv (& (SUC i) pow 2)) ((\i. n - i) i))` THEN1
		RW_TAC std_ss [REAL_POW_INV] THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	MATCH_MP_TAC REAL_EQ_IMP_LE THEN
	MATCH_MP_TAC SUM_PERMUTE_0 THEN
	RW_TAC std_ss [EXISTS_UNIQUE_THM] THENL [
		EXISTS_TAC (--`n - y:num`--) THEN
		RW_TAC arith_ss [],

		RW_TAC arith_ss []]);

val VARIANCE_CCP = store_thm
 ("VARIANCE_CCP",
 (--`!n. (variance (sum_rv_lst (geo_rv_unif_lst (my_coupon_lst n) (SUC n))) <= 
			(&(SUC n) pow 2) * (sum (0,(SUC n)) (\i. 1/((&(SUC i)) pow 2))))`--),
	RW_TAC std_ss [] THEN
	MP_TAC (Q.SPEC `n` MEM_MY_COUPON_LST_LT_SUCN) THEN
	MP_TAC (Q.SPEC `n` DIST_LST_MY_COUPON_LST) THEN
	MP_TAC NUM_NUM_POWN_ZERO THEN
 	REPEAT STRIP_TAC THEN
	SUFF_TAC `(geo_rv_unif_lst (my_coupon_lst n) (SUC n)) = 
		 (geo_rv_lst n (SUC n))` THEN1
		RW_TAC std_ss [VARIANCE_SUM_GEO_RV_LIST] THEN

		KNOW_TAC `n < SUC n` THEN1
			DECIDE_TAC THEN
		KNOW_TAC `0 < SUC n` THEN1
			DECIDE_TAC THEN
		NTAC 3 (POP_ASSUM MP_TAC) THEN
		Q.SPEC_TAC (`SUC n`, `k`) THEN
		RW_TAC std_ss [] THEN
		Cases_on `k` THEN1
			FULL_SIMP_TAC arith_ss [] THEN
	
			Induct_on `n` THEN1 (
				RW_TAC std_ss [my_coupon_lst_def, geo_rv_lst_def,
				geo_rv_unif_lst_def]) THEN

				RW_TAC std_ss [my_coupon_lst_def, geo_rv_unif_lst_def,
				geo_rv_lst_def] THENL [
					KNOW_TAC `(prob bern {s |
          					~IS_EL (FST (prob_uniform (SUC n') s))
             					(n::my_coupon_lst n)}) = 
						1 - (&(LENGTH (n::my_coupon_lst n)))/(&((SUC n')))` THEN1 (
						MATCH_MP_TAC PROB_BERN_NEW_COUPON THEN
						RW_TAC std_ss [dist_lst_def, MEM]) THEN
					RW_TAC std_ss [] THEN
					MATCH_MP_TAC RAND_THM THEN
					KNOW_TAC `& (SUC n' - SUC n) = 
						& (SUC n') - &(SUC n)` THEN1
						RW_TAC arith_ss [REAL_SUB] THEN
					ASM_REWRITE_TAC [] THEN
					RW_TAC arith_ss [GSYM REAL_DIV_ADD, real_sub, 
					REAL_DIV_REFL, REAL_POS_NZ, REAL_LT, REAL_EQ_LADD] THEN
					RW_TAC std_ss [REAL_INJ, real_div, REAL_NEG_LMUL, REAL_EQ_RMUL, REAL_EQ_NEG] THEN
					DISJ2_TAC THEN
					KILL_TAC THEN
					Induct_on `n` THEN1
						RW_TAC arith_ss [LENGTH, my_coupon_lst_def] THEN
	
						RW_TAC arith_ss [LENGTH, my_coupon_lst_def],
			
					FULL_SIMP_TAC std_ss [dist_lst_def, MEM]]);






val CC_CHEBYSHEV_BOUND = store_thm
 ("CC_CHEBYSHEV_BOUND",
 (--`!n a. (0 < a) /\ (0 < variance (sum_rv_lst (geo_rv_unif_lst (my_coupon_lst n) (SUC n)))) ==>
	 (prob bern {s | abs (&(FST ((sum_rv_lst (geo_rv_unif_lst (my_coupon_lst n) (SUC n))) s)) - 
		expec (sum_rv_lst (geo_rv_unif_lst (my_coupon_lst n) (SUC n)))) >= a} <= 
			((&(SUC n) pow 2) * (sum (0,(SUC n)) (\i. 1/((&(SUC i)) pow 2))))/(a pow 2))`--),
	RW_TAC std_ss [] THEN
	MATCH_MP_TAC REAL_LE_TRANS THEN
	EXISTS_TAC (--`(variance (sum_rv_lst (geo_rv_unif_lst (my_coupon_lst n) (SUC n))))/ a pow 2`--) THEN
	CONJ_TAC THENL [
		MATCH_MP_TAC CHEBYSHEVS_INEQUALITY_ALT THEN
		RW_TAC std_ss [EXPEC_CCP_HELPER] THENL [
			MATCH_MP_TAC INDEP_FN_SUM_RV_LIST THEN
			RW_TAC std_ss [] THEN
			MATCH_MP_TAC INDEP_FN_GEO_RV_LIST THEN
			EXISTS_TAC (--`n:num`--) THEN
			EXISTS_TAC (--`SUC n:num`--) THEN
			RW_TAC arith_ss [],

			MATCH_MP_TAC SUM_N_RV_SUMMABLE THEN
			RW_TAC std_ss [EXPEC_CCP_HELPER] THENL [
				MATCH_MP_TAC INDEP_FN_GEO_RV_LIST THEN
				EXISTS_TAC (--`n:num`--) THEN
				EXISTS_TAC (--`SUC n:num`--) THEN
				RW_TAC arith_ss [],

				MATCH_MP_TAC SUMMABLE_GEO_RV_LIST THEN
				EXISTS_TAC (--`n:num`--) THEN
				EXISTS_TAC (--`SUC n:num`--) THEN
				RW_TAC arith_ss []],

			MATCH_MP_TAC SECOND_MOMENT_SUM_N_RV_SUMMABLE THEN
			RW_TAC std_ss [] THENL [
				MATCH_MP_TAC INDEP_FN_GEO_RV_LIST THEN
				EXISTS_TAC (--`n:num`--) THEN
				EXISTS_TAC (--`SUC n:num`--) THEN
				RW_TAC arith_ss [],

				MATCH_MP_TAC SUMMABLE_SECOND_MOMENT_GEO_RV_LIST THEN
				EXISTS_TAC (--`n:num`--) THEN
				EXISTS_TAC (--`SUC n:num`--) THEN
				RW_TAC arith_ss [],		

				MATCH_MP_TAC SUMMABLE_GEO_RV_LIST THEN
				EXISTS_TAC (--`n:num`--) THEN
				EXISTS_TAC (--`SUC n:num`--) THEN
				RW_TAC arith_ss []]],

		RW_TAC real_ss [real_div, REAL_POW_LT, REAL_LE_RMUL, EXPEC_CCP_HELPER] THEN
		ONCE_REWRITE_TAC [REAL_INV_1OVER] THEN
		RW_TAC real_ss [VARIANCE_SUM_GEO_RV_LIST]]);

val _ = export_theory();